package com.persagy.server.datacenter.models.entities.assistant

import com.alibaba.fastjson.annotation.JSONField
import com.persagy.service.models.SBaseEntity
import io.swagger.v3.oas.annotations.media.Schema
import java.io.Serializable
import javax.persistence.Column
import javax.persistence.Id

/**
 * 业务空间类型
 */
@Schema(description = "业务空间类型")
class DictSpaceProject: SBaseEntity(),Serializable {

    /** 编码 */
    @Schema(description = "编码")
    @Id
    @Column(name = "id")
    @JSONField(name = "code")
    var id: String? = null

    /** 名称 */
    @Schema(description = "名称")
    @Column(name = "name")
    var name: String? = null

    /** 父类指针 */
    @Schema(description = "父类指针")
    @Id
    @Column(name = "parent_id")
    var parentId: String? = null

    /** 项目id */
    @Schema(description = "项目id")
    @Id
    @Column(name = "project_id")
    var projectId: String? = null

    /** 标记 */
    @Schema(description = "标记")
    @Column(name = "sign")
    var sign: Int? = null

    /** 数量 */
    @Schema(description = "数量")
    var count: Int? = 0

}