/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.datacenter.models.entities.dictnew

import com.persagy.service.models.SBaseEntity
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 平台字典对象类型
 *
 * @author  wx
 * @date  2020/9/19 16:37
 */
@Schema(description = "平台字典对象类型")
@Table(name = "dict.def_class")
class DefClass : SBaseEntity(){

    /** 全局id */
    @Schema(description = "全局 id")
    @Id
    @Column(name = "id")
    var  id: String? = null

    /** 编码 */
    @Schema(description = "编码")
    @Id
    @Column(name = "code")
    var  code: String? = null

    @Schema(description = "名称")
    @Column(name = "name")
    var name: String? = null

    @Schema(description = "别编码")
    @Column(name = "alias_code")
    var aliasCode: String? = null

    @Schema(description = "别编名")
    @Column(name = "alias_name")
    var aliasName: String? = null

    @Schema(description = "分类:common平台级, group集团级, project项目级")
    @Id
    @Column(name = "type")
    var type: String? = null

    @Schema(description = "集团id, 默认为 '0' ")
    @Id
    @Column(name = "group_code")
    var groupCode: String? = ""

    @Schema(description = "项目id, 默认为 '0' ")
    @Id
    @Column(name = "project_id")
    var projectId: String? = ""

    @Schema(description = "上级类型编码")
    @Column(name = "parent_code")
    var parentCode: String? = null

    @Schema(description = "专业编码")
    @Column(name = "major_code")
    var majorCode: String? = null

    @Schema(description = "系统编码")
    @Column(name = "system_code")
    var systemCode: String? = null

    @Schema(description = "部件所属的设备类型")
    @Column(name = "equipment_code")
    var equipmentCode: String? = null

    @Schema(description = "对象类型")
    @Column(name = "obj_type")
    var objType: String? = null

    @Schema(description = "子列表")
    var children:ArrayList<DefClass>? = null

} // Class DefClass