/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.datacenter.models.entities.graphtype.block

import com.persagy.server.datacenter.models.entities.base.RBaseInfo
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 源末端
 *
 * @author  邓婷婷
 */
@Schema(description = "源末端实体类")
@Table(name = "revit_calc.connected_block")
open class ConnectedBlock : RBaseInfo() {
    /** id */
    @Schema(description = "id")
    @Id
    @Column(name = "id")
    var id: Long? = null

    /** id1 */
    @Schema(description = "id1")
    @Column(name = "id1")
    var id1: String? = null

    /** type1 */
    @Schema(description = "type1")
    @Column(name = "type1")
    var type1: String? = null

    /** model_id1 */
    @Schema(description = "model_id1")
    @Column(name = "model_id1")
    var modelId1: String? = null

    /** id2 */
    @Schema(description = "id2")
    @Column(name = "id2")
    var id2: String? = null

    /** type2 */
    @Schema(description = "type2")
    @Column(name = "type2")
    var type2: String? = null

    /** model_id2 */
    @Schema(description = "model_id2")
    @Column(name = "model_id2")
    var modelId2: String? = null

    /** direction */
    @Schema(description = "direction, 1表示从id1流向id2, -1 表示从id2流向id1, 0表示不确定流向")
    @Column(name = "direction")
    var direction: Int? = null

    /** block_id */
    @Schema(description = "block_id")
    @Column(name = "block_id")
    var blockId: String? = null

    /** project_id */
    @Schema(description = "project_id")
    @Column(name = "project_id")
    var projectId: String? = null

    /** depth */
    @Schema(description = "depth")
    @Column(name = "depth")
    var depth: Int? = null

    /** mep_system_type */
    @Schema(description = "mep_system_type")
    @Column(name = "mep_system_type")
    var mepSystemType: String? = null

    /** domain */
    @Schema(description = "domain")
    @Column(name = "domain")
    var domain: String? = null

    /** building_id */
    @Schema(description = "building_id")
    @Column(name = "building_id")
    var buildingId: String? = null

    /** typecode1 */
    @Schema(description = "type_code1")
    @Column(name = "type_code1")
    var typeCode1: String? = null

    /** typecode2 */
    @Schema(description = "type_code2")
    @Column(name = "type_code2")
    var typeCode2: String? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as ConnectedBlock

        if (id1 == other.id1 && id2 == other.id2) return true
        if (id1 == other.id2 && id2 == other.id1) return true
        if (projectId != other.projectId) return false
        if (buildingId != other.buildingId) return false

        return false
    }

    override fun hashCode(): Int {
        var result = id1?.hashCode() ?: 0
        result = 31 * result + (id2?.hashCode() ?: 0)
        result = 31 * result + (projectId?.hashCode() ?: 0)
        result = 31 * result + (buildingId?.hashCode() ?: 0)
        return result
    }


}