/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.graphtype.block

import com.persagy.server.datacenter.models.entities.base.RBaseInfo
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Table

/**
 * 源末端
 *
 * @author  邓婷婷
 */
@Schema(description = "源末端")
@Table(name = "revit_calc.v_connected_block")
open class ConnectedBlockFamilyItem : RBaseInfo() {

    /** id */
    @Schema(description = "id")
    @Column(name = "id")
    var id: String? = null

    /** type */
    @Schema(description = "type")
    @Column(name = "type")
    var type: String? = null

    /** model_id */
    @Schema(description = "model_id")
    @Column(name = "model_id")
    var modelId: String? = null

    /** block_id */
    @Schema(description = "block_id")
    @Column(name = "block_id")
    var blockId: String? = null

    /** 项目id */
    @Schema(description = "项目id")
    @Column(name = "project_id")
    var projectId: String? = null

    /** 建筑id */
    @Schema(description = "建筑id")
    @Column(name = "building_id")
    var buildingId: String? = null

    /** 系统类型所属域 */
    @Schema(description = "系统类型所属域")
    @Column(name = "domain")
    var domain: String? = null

    /** 系统类型名称 */
    @Schema(description = "系统类型名称")
    @Column(name = "mep_system_type")
    var mepSystemType: String? = null

    /** local_id */
    @Schema(description = "local_id")
    @Column(name = "local_id")
    var localId: String? = null

    /** local_name */
    @Schema(description = "local_name")
    @Column(name = "local_name")
    var localName: String? = null

    /** 设备类型名 : 4位编码 */
    @Schema(description = "设备类型名")
    @Column(name = "family")
    var family: String? = null

    /** 模型中的id */
    @Schema(description = "模型中的id")
    @Column(name = "source_id")
    var sourceId: String? = null

    /** 名字 */
    @Schema(description = "名字")
    @Column(name = "name")
    var name: String? = null

    /** family_name */
    @Schema(description = "family_name")
    @Column(name = "family_name")
    var familyName: String? = null

    /** family_symbol */
    @Schema(description = "family_symbol")
    @Column(name = "family_symbol")
    var familySymbol: String? = null

    /** true是源, false是末端 */
    @Schema(description = "true是源, false是末端")
    @Column(name = "is_source")
    var isSource: Boolean? = null



}