/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.objects

import com.persagy.server.datacenter.models.entities.assistant.PointImage
import com.persagy.server.datacenter.models.entities.base.RBaseInfo
import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 点位标签信息实体类
 *
 * @ 付国宝
 */
@Schema(description = "点位标签信息实体类")
@Table(name = "location_point")
class LocationPoint : RBaseInfo() {

    /** 点位标签ID */
    @Schema(description = "点位标签ID")
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 本地编码 */
    @Schema(description = "本地编码")
    @Column(name = "local_id")
    var localId: String? = null

    /** 项目ID */
    @Schema(description = "项目ID")
    @Column(name = "project_id")
    var projectId: String? = null

    /** 建筑ID */
    @Schema(description = "建筑ID")
    @Column(name = "build_id")
    var buildId: String? = null

    /** 楼层ID */
    @Schema(description = "楼层ID")
    @Column(name = "floor_id")
    var floorId: String? = null

    /** BimId编码 */
    @Schema(description = "BimId编码")
    @Column(name = "bim_id")
    var bimId: String? = null

    /**  */
    @Schema(description = "")
    @Column(name = "beacon_id")
    var beaconId: String? = null

    /** 名称 */
    @Schema(description = "名称")
    @Column(name = "name")
    var name: String? = null

    /** 位置 */
    @Schema(description = "位置")
    @Column(name = "position")
    var position: String? = null

    /** 信息类型 */
    @Schema(description = "信息类型")
    @Column(name = "type")
    var type: Int? = null

    /** X坐标 */
    @Schema(description = "X坐标")
    @Column(name = "x")
    var x: Double? = 0.0

    /** Y坐标 */
    @Schema(description = "Y坐标")
    @Column(name = "y")
    var y: Double? = 0.0

    /**  */
    @Schema(description = "")
    @Column(name = "space_id")
    var spaceId: String? = null

    /** 备注 */
    @Schema(description ="")
    @Column(name = "note")
    var note: String? = null

    /** 图片信息 */
    @Schema(description ="图片信息")
    @SCascade(table="scanbuilding.image", idColumn="object_id", childIdColumn="id")
    var imageList: ArrayList<PointImage>? = null

//    /** 图片信息 */
//    @Schema(description ="图片信息")
//    @JSONField(name = "videoList")
//    @SCascade(table="scanbuilding.image", idColumn="object_id", childIdColumn="id")
//    var videoList: ArrayList<PointImage>? = null

//    /** 图片列表信息 */
//    @Schema(description ="图片列表信息")
//    @JSONField(name = "ImageLists")
//    @Column(name = "image_list")
//    var imageLists: HashMap<String,PointImage>? = null


} // Class LocationPoint