/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.rel

import com.alibaba.fastjson.annotation.JSONField
import com.google.gson.annotations.SerializedName
import com.persagy.server.datacenter.models.entities.base.RBaseInfo
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 设备服务于楼层实体类
 *
 * @author 付国宝
 */
@Schema(name = "元空间的邻接关系")
@Table(name = "r_spatial_connection")
class RSpatialConnection : RBaseInfo() {

    /** 空间id */
    @Schema(description = "空间id")
    @Column(name = "space_id_one")
    @Id
    var spaceIdOne: String? = null

    /** 邻接的空间id */
    @Schema(description = "邻接的空间id")
    @Column(name = "space_id_two")
    @Id
    var spaceIdTwo: String? = null

    /** 位置坐标 */
    @Schema(description = "位置坐标")
    @Column(name = "location_one")
    var locationOne: String? = null

    /** 邻接的元空间id */
    @Schema(description = "邻接的元空间id")
    @Column(name = "location_two")
    var locationTwo: String? = null

    /** 项目id */
    @Schema(description = "项目id")
    @Column(name = "project_id")
    var projectId: String? = null

    /** 计算标记 1 为手动 2为自动 */
    @Schema(description = "计算标记 1 为手动 2为自动 ")
    @Column(name = "sign")
    var sign: Int? = null

    /** 图类型id */
    @Schema(description = "图类型id")
    @Column(name = "graph_type")
    var graphType: String? = null

    /** 边类型id */
    @Schema(description = "边类型id")
    @Column(name = "rel_type")
    var relType: String? = null

    /** 对象类型 */
    @Schema(description = "对象类型")
    @Column(name = "zone_type")
    var zoneType: String? = null

    /** 楼层id */
    @Schema(description = "楼层id")
    @Column(name = "floor_id")
    var floorId: String? = null

}