/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.jms

import java.io.Serializable
import java.util.*
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 同步消息体
 *
 * @author 张维新
 */
@Table(name = "synchronization.sync_data_relation")
class SynchronousMessageRel : Serializable {

    /** 同步任务 id */
    @Column(name = "id")
    @Id
    var id: String? = null

    /** 项目 id */
    @Column(name = "project_id")
    var projectId: String? = null

    /** 操作类型 ，创建、修改、删除 */
    @Column(name = "type")
    var type: String? = null

    /** 标记 0已处理，1待处理，2处理失败 */
    @Column(name = "sign")
    var sign: Int? = null

    /** 操作符 */
    @Column(name = "ops")
    var ops: String? = null
    /** 主 id */
    @Column(name = "from_id")
    var fromId: String? = null
    /** 从 id */
    @Column(name = "to_id")
    var toId: String? = null
    /** 失败数量统计 */
    @Column(name = "count")
    var count: Int = 0


    /** 最后更新日期 */
    @Column(name = "last_update", updatable = false, insertable = false)
    var lastUpdate: Date? = null

    /** 创建时间 */
    @Column(name = "create_time", updatable = false, insertable = false)
    var createTime: Date? = null

} // Class SynchronousMessageObj