package com.persagy.server.datacenter.models.requests

import io.swagger.v3.oas.annotations.media.Schema
import java.io.Serializable
import javax.validation.constraints.NotNull

/**
 * 添加关系
 *
 * @author 张维新
 */
class RelationAddRequest : Serializable {

    @Schema(description = "需要计算的类型")
    @NotNull(message = "关系类型不可以为空")
    var relType: String? = null

    @Schema(description = "编码类型，CADID图纸编码(cadId),设备名称(name),设备ID(id),本地编码(localId),本地名称(localName)")
    @NotNull(message = "编码类型不可以为空")
    var type: String? = null

    @Schema(description = "主对象内容")
    @NotNull(message = "主对象内容不可以为空")
    var mainContent: String? = null

    @Schema(description = "从对象内容")
    @NotNull(message = "从对象内容不可以为空")
    var fromContent: ArrayList<String>? = null

    @Schema(description = "图类型")
    @NotNull(message = "图类型不可以为空")
    var graphicCode: String? = null

}