package com.persagy.server.datacenter.wanda

import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 设备对照表
 * @author  Cainga
 * @date  2020/12/3 15:53
 */

@Schema(description = "设备对照")
@Table(name = "revit.equip_comp")
@JsonIgnoreProperties(ignoreUnknown = true)
open class EquipComp {

//    /** id */
//   @Schema(description = "id")
    @Column(name = "id", updatable = false)
    @Id
    var id: Int? = null

    /** 万达BIMTypeID */
    @Schema(description = "万达BIMTypeID")
    @Column(name = "bim_type_id")
//    @JSONField(name = "BIMTypeID")
//    @JsonProperty("BIMTypeID")
    var bimTypeId: String? = null

    /** 万达BIMTypeName */
    @Schema(description = "万达BIMTypeName")
    @Column(name = "bim_type_name")
//    @JSONField(name = "BIMTypeID")
//    @JsonProperty("BIMTypeID")
    var bimTypeName: String? = null

    /** 系统分类 */
    @Schema(description = "系统分类")
    @Column(name = "sys_name")
    var sysName: String? = null


    /** 设备设施类编码 */
    @Schema(description = "设备设施类编码")
    @Column(name = "class_code")
    var classCode: String? = null
    set(description) {
        field = description?.trim()
    }


    /** 设备设施类名称 */
    @Schema(description = "设备设施类名称")
    @Column(name = "class_name")
    var className: String? = null


//    /** 慧云码*/
//    @Schema(description = "慧云码")
//    @Column(name = "alias_code")
//    var aliasCode: String? = null
}