package com.persagy.server.datacenter.wanda.dict

import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 万达对照表
 *
 * @author wx
 */
@Schema(description = "字典万达对照表")
@Table(name = "dict.dict_info_wanda")
class DictInfosWanDa {

    /** id */
    @Schema(description = "id")
    @Column(name = "id")
    var id: String? = null
    /** 集团编码 */
    @Schema(description = "集团编码")
    @Id
    @Column(name = "group_code")
    var groupCode: String? = null
    /** 项目 id */
    @Schema(description = "项目id")
    @Id
    @Column(name = "project_id")
    var projectId: String? = null
    /** 类型 */
    @Schema(description = "类型")
    @Id
    @Column(name = "class_code")
    var classCode: String? = null
    /** 信息点编码 */
    @Schema(description = "信息点编码")
    @Id
    @Column(name = "code")
    var code: String? = null
    /** 信息点名称 */
    @Schema(description = "信息点名称")
    @Column(name = "name")
    var name: String? = null
    /** 阶段 */
    @Schema(description = "阶段")
    @Id
    @Column(name = "stage")
    var stage: String? = null

}