/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.wanda.obj
import com.persagy.server.datacenter.models.entities.base.BaseInfo
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 项目信息实体类
 *
 * @author  张维新
 */
@Schema(description = "项目信息实体类")
@Table(name = "project")
open class Project : BaseInfo() {

    /** 项目ID */
    @Schema(description = "项目ID")
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 项目名称 */
    @Schema(description = "项目名称")
    @Column(name = "name")
    var name: String? = null

    /** 项目本地编码 */
    @Schema(description = "项目本地编码")
    @Column(name = "local_id")
    var localId: String? = null

    /** 项目本地名称 */
    @Schema(description = "项目本地名称")
    @Column(name = "local_name")
    var localName: String? = null

    /** 项目介绍 */
    @Schema(description = "项目介绍")
    @Column(name = "introduction")
    var introduction: String? = null

    /** 商业层数 */
    @Schema(description = "商业层数")
    @Column(name = "business_floor_num")
    var businessFloorNum: String? = null

    /** 办公层数 */
    @Schema(description = "办公层数")
    @Column(name = "office_floor_num")
    var officeFloorNum: String? = null

    /** 对象类型 */
    @Schema(description = "对象类型")
    @Column(name = "object_type")
    override var objectType: String? = "Project"

    @Schema(description = "信息点")
    @Column(name = "infos")
    var infos: HashMap<String,Any?>? = null

    /** 集团编码 */
    @Schema(description = "集团编码")
    @Column(name = "group_code")
    var groupCode: String? = null
}