package com.persagy.server.datacenter.wanda.rel

import RelBuilding
import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Table

/**
 * 建筑和楼层的关系
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2021/2/27 16:37
 */
@Schema(description = "建筑信息实体类")
@Table(name = "building")
class RBd2SpBuiliding: RelBuilding() {

    /** 级联-设备服务的建筑 */
    @Schema(description = "级联-设备服务的建筑")
    @SCascade(table="public.zone_space_base", idColumn="building_id", childIdColumn="id")
    var objectInfo: ArrayList<RelZoneSpaceBd>? = null
}