package com.persagy.server.datacenter.wanda.rel

import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Table

/**
 * 设备和建筑的关系
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2021/2/25 18:16
 */
@Schema(description = "设备信息实体类")
@Table(name = "equipment")
class RelEq2SpForEquip: EquipmentBase() {

    /** 级联-设备服务的建筑 */
    @Schema(description = "级联-设备服务的建筑")
    @SCascade(table="relationship.r_eq2sp", idColumn="eq_id", childIdColumn="sp_id" ,filter = "graph_code = 'MechForArch'")
    var objectInfo: ArrayList<RelZoneSpaceBd>? = null

}