package com.persagy.server.datacenter.wanda.response

import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.wanda.dict.DictStage
import com.persagy.service.models.enums.SResponseType
import io.swagger.v3.oas.annotations.media.Schema
import java.io.Serializable

/**
 * 设备字典应答类
 *
 * @author wx
 */
@Schema(description = "设备字典应答类")
class DictInfoResponse : Serializable {

    /** 基础信息点 */
    @Schema(description = "基础信息点")
    var basicInfos: ArrayList<DefFuncId>? = null
    /** 阶段 */
    @Schema(description = "阶段")
    var dictStages: ArrayList<DictStage>? = null
    /** 结果 */
    @Schema(description = "结果")
    var result: SResponseType = SResponseType.failure
    /** 消息 */
    @Schema(description = "消息")
    var message: String = ""

}