/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server

import com.persagy.service.SPageContext
import com.persagy.service.utils.SSpringContextUtil

/**
 * 常量池
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/27 21:07
 */
object Opt {
    /** MQ消息对象 */
    val configure by lazy {
        SSpringContextUtil.getBean(Configure::class.java) as Configure
    }

    /** 交换机名 */
    val exchange: String?
    get() = configure.exchange
    /** key */
    val routingKey: String?
    get() = configure.routingKey

    /** 创建 */
    const val CREATE = "create"
    /** 修改 */
    const val UPDATE = "update"
    /** 删除 */
    const val DELETE = "delete"

    /** 项目 id */
    val projectId: String?
        get() = SPageContext.getHeader("projectId")
    /** 数据来源 */
    val coming: String?
        get() = SPageContext.getHeader("coming")
    /** 账号信息 */
    val account: String?
        get() = SPageContext.getHeader("account")

    /**  使用字典信息点全局定义 ****************************************************************************/
    /** 楼层平面图 */
    const val FLOORMAP = "floorMap"
    /**楼层标高 */
    const val FLOORELEVATION = "floorElevation"
    /** 高度 */
    const val HEIGHt = "height"
    /** 安装位置 */
    const val INSTALLLOCATION = "installLocation"
    /** 生产厂家名称 */
    val MANUFACTURER = "manufacturer"
    /** 设备型号 */
    val SPECIFICATION = "Specification"
    /** 供应商单位名称 */
    val SUPPLIER = "Supplier"
    /** 设备照片 */
    val PIC = "pic"
    /** 竖井类型 */
    val SHAFTFUNCTYPE = "shaftFuncType"

    /** 关系 *******************************************************************************************/
    /** 传感器关系 */
    const val SensorRelationship = "SensorRelationship"
    /** 建筑交通网络 */
    const val TrafficNetwork = "TrafficNetwork"
    /** 传感器通信网络 */
    const val SensorNetwork = "SensorNetwork"
    /** 空调冷冻水环路 */
    const val ChillWaterLoop = "ChillWaterLoop"
    /** 采暖水环路 */
    const val HeatWaterLoop = "HeatWaterLoop"
    /** 燃气系统 */
    const val GasNetwork = "GasNetwork"
    /** 高压变配电网络 */
    const val HUDistribution = "HUDistribution"
    /** 多联机系统 */
    const val VRFNetwork = "VRFNetwork"
    /** 空调冷却水环路 */
    const val CoolingWaterLoop = "CoolingWaterLoop"
    /** 空调冷凝水网络 */
    const val CondWaterNetwork = "CondWaterNetwork"
    /** 阀门关系 */
    const val ValveRelationship = "ValveRelationship"
    /** 低压配电网络 */
    const val LUDistribution = "LUDistribution"
    /** 设备供电关系 */
    const val EquipPower = "EquipPower"
    /** 消防供水网络 */
    const val FireWaterNetwork = "FireWaterNetwork"
    /** 消防排烟网络 */
    const val FireVentNetwork = "FireVentNetwork"
    /** 光照辐射网络 */
    const val RadiationNetwork = "RadiationNetwork"
    /** 设备空间其他关系 */
    const val EquipXSpace = "EquipXSpace"
    /** 排水网络 */
    const val DrainingWaterNetwork = "DrainingWaterNetwork"
    /** 给水网络 */
    const val SupplyWaterNetwork = "SupplyWaterNetwork"
    /** 新风管网 */
    const val FreshAirNetwork = "FreshAirNetwork"
    /** 控制设备网络 */
    const val ControlEquipNetwork = "ControlEquipNetwork"
    /** 中水系统 */
    const val RecycleWaterNetwork = "RecycleWaterNetwork"
    /** 生活热水网络 */
    const val DHWNetwork = "DHWNetwork"
    /** 资产所在区域关系 */
    const val PropertyInArch = "PropertyInArch"
    /** 机电类服务区域关系 */
    const val MechForArch = "MechForArch"
    /** 直饮水网络 */
    const val DrinkingWaterNetwork = "DrinkingWaterNetwork"
    /** 空气流通网络 */
    const val ConvectionNetwork = "ConvectionNetwork"
    /** 通风管网 */
    const val VentNetwork = "VentNetwork"
    /** 空调风管网 */
    const val ACAirNetwork = "ACAirNetwork"
    /** 设备控制关系 */
    const val ControlRelation = "ControlRelation"
    /** 空间邻接关系 */
    const val SpaceNeighborhood = "SpaceNeighborhood"

    /** 关系边类型 **************************************************************************************************/
    /** 资产所在的竖井 */
    const val Pe2Sh = "Pe2Sh"
    /** 资产所在业务空间 */
    const val Pe2Sp = "Pe2Sp"
    /** 系统和建筑 */
    const val Sy2Bd = "Sy2Bd"
    /** 系统和楼层 */
    const val Sy2Fl = "Sy2Fl"
    /** 系统和竖井 */
    const val Sy2Sh = "Sy2Sh"
    /** 系统和业务空间 */
    const val Sy2Sp = "Sy2Sp"
    /** 设备和建筑 */
    const val Eq2Bd = "Eq2Bd"
    /** 设备和楼层 */
    const val Eq2Fl = "Eq2Fl"
    /** 设备和竖井 */
    const val Eq2Sh = "Eq2Sh"
    /** 设备和空间 */
    const val Eq2Sp = "Eq2Sp"
}