/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.mappers

import org.apache.ibatis.annotations.Mapper
import org.apache.ibatis.annotations.Param
import org.apache.ibatis.annotations.Select
import org.springframework.stereotype.Repository

/**
 * 自定义 SQL
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/15 21:12
 */
@Mapper
@Repository
interface CustomMapper {

    /**
     * 批量导入数据
     *
     * @param projectId  项目id
     * @param groudCode  集团编码
     */
    @Select("INSERT INTO dict.def_funcid_project(id,class_code,category,code,name,type,group_code,project_id,data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code) SELECT id,class_code,category,code,name,type,group_code,#{projectId},data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code FROM  dict.def_funcid WHERE group_code =#{groudCode} and project_id = #{projectId}")
    fun dictSchemeData(@Param("projectId") projectId: String,@Param("groudCode") groudCode: String)

    /**
     * 批量导入数据
     *
     * @param projectId  项目id
     * @param groudCode  集团编码
     */
    @Select("INSERT INTO dict.def_funcid_project(id,class_code,category,code,name,type,group_code,project_id,data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code) SELECT id,class_code,category,code,name,type,group_code,'Pj1101050029',data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code FROM  dict.def_funcid_scheme WHERE group_code =#{groudCode} AND scheme_id = 1")
    fun dictSchemeDataTwo(@Param("projectId") projectId: String,@Param("groudCode") groudCode: String)

    /**
     * 批量导入数据
     *
     * @param projectId  项目id
     * @param groudCode  集团编码
     */
    @Select("INSERT INTO dict.def_funcid_project(id,class_code,category,code,name,type,group_code,project_id,data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code) SELECT id,class_code,category,code,name,type,group_code,'Pj1101050029',data_type,formater,data_source,input_mode,first_tag,second_tag,idx,priority,unit,note,can_sub,is_multiple,is_region,sub_flag,readonly,visible,editable,sort,un_disabled,object_type,key_word,last_update,create_time,first_name,second_name,alias_code,alias_name,orig_data_type,orig_code FROM  dict.def_funcid_scheme WHERE group_code =#{groudCode} AND scheme_id = 2")
    fun dictSchemeDataWanDa(@Param("projectId") projectId: String,@Param("groudCode") groudCode: String)

}