/*
 * ********************************************************************************************************************
 *
 *                      :*$@@%$*:                         ;:                ;;    ;;
 *                    :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                   :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                   =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                   =@*                                  %!              @ $= % %@=   =%@!      %=
 *              *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *            %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *          ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *          $@*   ;@@@%=!:                *@*
 *          =@$    ;;;!=%@@@@=!           =@!
 *           %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *            ;%@@$=$@@%*       *@@@$=%@@%;
 *               ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */

package cn.sagacloud.server.algorithm.models.entities


import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.persagy.server.datacenter.models.entities.graphtype.MLocation
import com.persagy.server.datacenter.models.entities.graphtype.MPoint
import javax.persistence.Column
import javax.persistence.Table
/**
 * 门
 *
 * @author jxing
 */
@Table(name = "revit.door")
@JsonIgnoreProperties(ignoreUnknown = true)
class Door : WindowDoorBase() {

    /** 名称 */
    @Column(name = "name")
    var name: String? = null


    /** 定位点 */
    @Column(name = "location")
    var location: MLocation? = null

    /** 轮廓线 */
    @Column(name = "outline")
    var outline: ArrayList<ArrayList<MPoint>>? = null

    /** 面方向 */
    @Column(name = "face_direction")
    var faceDirection : MPoint? = null

    /** Hand方向 */
    @Column(name = "hand_direction")
    var handDirection : MPoint? = null

    /** 类型中文名称 */
    @Column(name = "family_name")
    var familyName: String? = null

    /** 族符号 */
    @Column(name = "family_symbol")
    var familySymbol: String? = null


    @Column(name = "thick")
    var thick : Double? = null

    // 以下是json解析字段

//    @JSONField(name = "Owner")
//    var jsonOwner : String? = null //
//
//    @JSONField(name = "Location")
//    var jsonLocation : Location? = null //
//
//    @JSONField(name = "OutLine")
//    var jsonOutline : ArrayList<ArrayList<Point>>? = null //
//
//    @JSONField(name = "SourceId")
//    var jsonSourceId : String? = null //
//
//    @JSONField(name = "FaceDirection")
//    var jsonFaceDirection : Point? = null //
//
//    @JSONField(name = "HandDirection")
//    var jsonHandDirection : Point? = null //
//
//    @JSONField(name = "Thick")
//    var jsonThick : Double? = null //
//
//    @JSONField(name = "Id")
//    var jsonId : String? = null //
//
//    @JSONField(name = "ElementType")
//    var jsonElementType : String? = null //
//
//    @JSONField(name = "Name")
//    var jsonName: String? = null  //
}