/*
 * ********************************************************************************************************************
 *
 *                      :*$@@%$*:                         ;:                ;;    ;;
 *                    :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                   :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                   =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                   =@*                                  %!              @ $= % %@=   =%@!      %=
 *              *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *            %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *          ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *          $@*   ;@@@%=!:                *@*
 *          =@$    ;;;!=%@@@@=!           =@!
 *           %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *            ;%@@$=$@@%*       *@@@$=%@@%;
 *               ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */


package com.persagy.server.datacenter.models.entities

import cn.sagacloud.server.algorithm.models.entities.BaseComponent
import com.alibaba.fastjson.annotation.JSONField
import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonProperty
import com.persagy.server.datacenter.models.entities.graphtype.MLocation
import com.persagy.server.datacenter.models.entities.graphtype.MPoint
import javax.persistence.Column
import javax.persistence.Table

/**
 * 水管
 *
 * @author jxing
 */
@Table(name = "revit.pipe")
@JsonIgnoreProperties(ignoreUnknown = true)
class Pipe  : BaseComponent(){

    /** 名称 */
    @Column(name = "name")
    var name: String? = null

    /** 定位点 */
    @Column(name = "location")
    var location: MLocation? = null

    /** 设备轮廓 */
    @Column(name = "outline")
    var outline : ArrayList<ArrayList<MPoint>>? = null

    /** 连接的连接件id */
    @Column(name = "connected_ids")
    var connectedIds: ArrayList<String>? = null

    /** 管道系统类型名称 */
    @Column(name = "mep_system_type")
    var mepSystemType: String? = null

    /** 直径 */
    @Column(name = "diameter")
    var diameter: Double? = null

    /** 参数列表 */
    @Column(name = "parameters")
    var parameters: ArrayList<Parameter>? = null

    /** 管道类型 */
    @Column(name = "riser_state")
    var riserState: Int? = null
}