/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.services.assistant

import com.persagy.base.extensions.toJson
import com.persagy.base.extensions.toMap
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.assistant.ObjInfos
import com.persagy.server.datacenter.models.entities.tool.ObjectBaseRequest
import com.persagy.service.SObjectService
import org.json.JSONObject
import java.text.SimpleDateFormat

/**
 * 信息点服务
 * @author  蔡云飞
 */
object ObjInfoService :  SObjectService<ObjInfos>(SMybatisDao(ObjInfos::class.java)) {

    private val SIMPLEDATEFORMAT_DC = SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
    /**
     * @Description: 查找创建或更新信息点
     * @Param: entity,flag,objType,type
     */
    fun createInfo(entity: Any, flag: Boolean,objType: String,type: String){
        try {
            var request = ObjectBaseRequest()
            val infos = JSONObject(entity.toJson())
            val map = entity.toMap()
            val iterator = infos.keys()
            while (iterator.hasNext()) {
                val key = iterator.next()
                val value = infos.get(key as String)
                if (value!=null&&value.toString()!="null"){
                    request.addInfo(key, value, false)
                }
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }

//        val pro = PropertyDefProjectService.select(SFilter.eq("projectId",map["projectId"].toString()), SFilter.eq("type",type), SFilter.or(SFilter.eq("inputMode","L"), SFilter.eq("inputMode","M"))).exec()
//        val requestInfos = request.infos
//        if(requestInfos!=null){
//            if(pro!=null){
//
//                for (propertyDefProjectInfo in pro) {
//                    val infoPointCode = propertyDefProjectInfo.infoPointCode
//                    if(requestInfos.containsKey(infoPointCode)){
//                        var objInfos = ObjInfos()
//                        objInfos.objType = objType
//                        objInfos.projectId = map["projectId"].toString()
//                        objInfos.objId = map["id"].toString()
//                        objInfos.infoId = infoPointCode
//                        objInfos.value = requestInfos[infoPointCode].toString()
//                        if(flag){
//                            objInfos.time = SIMPLEDATEFORMAT_DC.format(Date())
//                            insert(objInfos)
//                        }else{
//                            objInfos.time = SIMPLEDATEFORMAT_DC.format(map["lastUpdate"].toString())
//                            update(objInfos)
//                        }
//                    }
//                }
//            }
//        }
    } // Fun

} // Object ObjInfoService