/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.utils

import java.util.*

/**
 * 竖井名称自动生成工具
 *
 * @author 张维新
 */
object ShaftNameUtil {

    /**
     * 竖井名字
     *
     * @param   name    名字
     */
    fun shaftName(name:String):String{
        return name + getCode(5)
    } // Function shaftName()

    /**
     * 字母和数字组合的随机数
     *
     * @param   n   随机数的位数
     */
    private fun getCode(n: Int): String {
        val string = "0123456789ABCDEFGHJKLMNPQRSTUVWXYZ"//保存数字0-9 和 大小写字母
        val ch = CharArray(n) //声明一个字符数组对象ch 保存 验证码
        for (i in 0 until n) {
            val random = Random()//创建一个新的随机数生成器
            val index = random.nextInt(string.length)//返回[0,string.length)范围的int值    作用：保存下标
            ch[i] = string[index]//charAt() : 返回指定索引处的 char 值   ==》保存到字符数组对象ch里面
        }
        //将char数组类型转换为String类型保存到result
        //String result = new String(ch);//方法一：直接使用构造方法      String(char[] value) ：分配一个新的 String，使其表示字符数组参数中当前包含的字符序列。
//        val result = String(ch)//方法二： String方法   valueOf(char c) ：返回 char 参数的字符串表示形式。
        return  String(ch)
    }// Function getCode()

} // Object ShaftNameUtil