/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn

import org.springframework.boot.context.properties.ConfigurationProperties
import org.springframework.stereotype.Component

/**
 * 配置信息
 *
 * @author 张维新
 */
@Component
@ConfigurationProperties(prefix = "saga")
open class Opts {
    

    /** 数据中台消息之创建 */
    val RWDCREATE = "instanceObjectCreate"
    /** 数据中台消息之修改 */
    val RWDUPDATE = "instanceObjectUpdate"
    /** 数据中台消息之删除 */
    val RWDDELETE = "instanceObjectDelete"


    /** 物理世界地址 */
    lateinit var dataPlatform: String
    lateinit var data_org: String
    lateinit var data_rwd: String
    lateinit var data_dic: String

    val SUCCESS_CODE = "success"


    val LedgerParam = "台账参数"
    val CommParam = "通讯参数"
    val TechParam = "技术参数"
    val RunParam = "运行参数"
    val SettingParam = "设定参数"
    val Alram = "报警消息"

    val GeoInfo = "地理位置"
    val StructureInfo = "结构信息"
    val PeopleInfo = "人员信息"
    val ProjectInfo = "项目信息"
    val CommercialInfo = "商业信息"
    val EnergyCost = "能源价格"
    val OutdoorEnv = "室外环境"
    val Weather = "天气预报"
    val ConsumptionInfo = "能耗信息"
    val BuildingInfo = "建筑信息"
    val BuildingDoc = "建筑文档"
    val Schedule = "工作历"
    val EnvParam = "环境参数"
    val TenantInfo = "租户信息"

}