/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2021.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.syn.controllers

import com.alibaba.fastjson.JSONObject
import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.wanda.EquipComp
import com.persagy.server.datacenter.wanda.dict.DictInfosWanDa
import com.persagy.server.datacenter.wanda.obj.Equipment
import com.persagy.server.syn.models.response.GroupResponse
import com.persagy.service.SObjectService
import com.persagy.service.models.enums.SResponseType
import com.persagy.service.models.responses.SBaseResponse
import io.swagger.v3.oas.annotations.Operation
import io.swagger.v3.oas.annotations.tags.Tag
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*
import org.springframework.web.client.RestTemplate

/**
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2021/1/12 9:31
 */
@Tag(name = "测试")
@RestController
@RequestMapping("/test01")
class TestController {

    companion object {
        // 日志
        private val logger = LoggerFactory.getLogger(TestController::class.java)
    } // Companion object
    /** 信息点 */
    private val defFuncIdService = SObjectService(SMybatisDao(DefFuncId::class.java))
    /** 对照表 */
    private val dictInfosWanDaService = SObjectService(SMybatisDao(DictInfosWanDa::class.java))
    /**
     * 设备服务
     */
    private val equipmentService = SObjectService(SMybatisDao(Equipment::class.java))

    private val equipCompService = SObjectService(SMybatisDao(EquipComp::class.java))



    // 注意获取这个实例
    @Autowired
    private val restTemplate: RestTemplate? = null

    val DMPORG = "http://DMP-ORG"
    /**
     * 测试获取 ip
     */
    @Operation(summary = "测试获取ip", description = "",tags = ["001"])
    @GetMapping(value = ["/test/ip"])
    fun groupInfo(): SBaseResponse {
        val jsonObject = JSONObject()
        val jsonObject2 = JSONObject()
        jsonObject["criteria"] = jsonObject2
        val patchForObject =
            restTemplate?.postForObject(DMPORG + "/org/group/query", jsonObject, GroupResponse::class.java)
        return SBaseResponse(SResponseType.success)
    }

    /**
     * 造对照表数据
     */
    @Operation(summary = "造对照表数据", description = "",tags = ["001"])
    @PostMapping(value = ["/test/analog/data"])
    fun analogData(@RequestParam groupCode: String,@RequestParam projectId: String): SBaseResponse{
        try {

            val equipmentList = equipCompService.selectAll().exec()

            var setCode = HashSet<String>()
            for (equipment in equipmentList){
                setCode.add(equipment.classCode!!)
            }
            logger.debug("类型= ${setCode.size}")
            for (type in setCode.toList()) {
                val defFuncIdList = defFuncIdService.select(SFilter.eq("classCode", type), SFilter.eq("projectId", "Pj4403070003")).exec()
                for (defFuncId in defFuncIdList){
                    if (!defFuncId.firstName.isNullOrEmpty()){
                        if (defFuncId.firstName == "台账参数"){
                            val dictInfosWanDa = DictInfosWanDa()
                            dictInfosWanDa.classCode = defFuncId.classCode
                            dictInfosWanDa.code = defFuncId.code
                            dictInfosWanDa.groupCode = groupCode
                            dictInfosWanDa.projectId = "0"
                            dictInfosWanDa.name = defFuncId.name
                            dictInfosWanDa.stage = "mdc"
                            dictInfosWanDaService.replace(dictInfosWanDa)
                        }else if (defFuncId.firstName == "技术参数") {
                            val dictInfosWanDa = DictInfosWanDa()
                            dictInfosWanDa.classCode = defFuncId.classCode
                            dictInfosWanDa.code = defFuncId.code
                            dictInfosWanDa.groupCode = groupCode
                            dictInfosWanDa.projectId = "0"
                            dictInfosWanDa.name = defFuncId.name
                            dictInfosWanDa.stage = "dpm"
                            dictInfosWanDaService.replace(dictInfosWanDa)
                        } else if (defFuncId.firstName == "运行参数"||defFuncId.firstName == "设定参数") {
                            val dictInfosWanDa = DictInfosWanDa()
                            dictInfosWanDa.classCode = defFuncId.classCode
                            dictInfosWanDa.code = defFuncId.code
                            dictInfosWanDa.groupCode = groupCode
                            dictInfosWanDa.projectId = "0"
                            dictInfosWanDa.name = defFuncId.name
                            dictInfosWanDa.stage = "moms"
                            dictInfosWanDaService.replace(dictInfosWanDa)
                        }
                    }
                }
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return SBaseResponse(SResponseType.success)
    }



}