/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.jms

import com.persagy.server.datacenter.syn.services.jms.*
import com.persagy.server.syn.Configure
import com.persagy.server.syn.jms.bean.SyncRwdDatacenterMessage
import com.persagy.server.syn.services.jms.*
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service

/**
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/11/2 22:15
 */
@Service
class RwdSync {
    /** 项目 */
    @Autowired
    lateinit var rwdProject: RwdProject
    /** 建筑 */
    @Autowired
    lateinit var rwdBuilding: RwdBuilding
    /** 楼层 */
    @Autowired
    lateinit var rwdFloor: RwdFloor
    /** 设备 */
    @Autowired
    lateinit var rwdEquip: RwdEquip
    /** 部件 */
    @Autowired
    lateinit var rwdComponent: RwdComponent
    /** 竖井 */
    @Autowired
    lateinit var rwdShaft: RwdShaft
    /** 系统 */
    @Autowired
    lateinit var rwdSystem: RwdSystem
    /** 空间 */
    @Autowired
    lateinit var rwdSpace: RwdSpace
    /** 添加关系 */
    lateinit var rwdRelationAdd: RwdRelationAdd
    /** 删除关系 */
    lateinit var rwdRelationDel: RwdRelationDel

    /**
     *
     */
    fun dataSync(messageList: ArrayList<SyncRwdDatacenterMessage>){
        for (message in messageList){
            if (message.type=="instanceObjectCreate"||message.type=="instanceObjectUpdate"||message.type=="instanceObjectDelete"){
                when(message.str1){
                    Configure.PROJECT -> {
                        /** 项目信息 */
                        rwdProject.projectType(message)
                    }
                    Configure.BUILDING -> {

                        /** 建筑 */
                        rwdBuilding.buildingType(message)
                    }
                    Configure.FLOOR -> {
                        /** 楼层 */
                        rwdFloor.floorType(message)
                    }
                    Configure.EQUIPMENT -> {
                        /** 设备 */
                        rwdEquip.equipType(message)
                    }
                    Configure.COMPONENT -> {
                        /** 部件 */
                        rwdComponent.componentType(message)
                    }
                    Configure.SHAFT -> {
                        /** 竖井 */
                        rwdShaft.shaftType(message)
                    }
                    Configure.SYSTEM -> {
                        /** 系统 */
                        rwdSystem.equipType(message)
                    }
                    Configure.SPACE -> {
                        /** 空间 */
                        rwdSpace.spaceType(message)
                    }
                }
            } else if (message.type=="instanceRelationCreate"||message.type=="instanceRelationDelete") {
                when(message.type){
                    Configure.RELATIONDELETE -> {
                        /** 删除关系 */
                        rwdRelationDel.delRelation(message)
                    }
                    Configure.RELATIONCREATE -> {
                        /** 创建关系 */
                        rwdRelationAdd.addRelation(message)
                    }
                }
            }
        }
    }


}