/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.jms.bean

import java.io.Serializable
import java.util.*
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 同步消息体
 *
 * @author 张维新
 */
@Table(name = "synchronization.sync_rwd_datacenter")
class SyncRwdDatacenterMessage : Serializable {

    /** 同步任务 id */
    @Column(name = "id")
    @Id
    var id: String? = null

    /** 执行类型 */
    @Column(name = "type")
    var type: String? = null

    /** 对象 id */
    @Column(name = "target_id")
    var targetId: String? = null

    /** 集团编码 */
    @Column(name = "group_code")
    var groupCode: String? = null

    /** 项目 */
    @Column(name = "project_id")
    var projectId: String? = null

    /** 发送时间 */
    @Column(name = "send_time")
    var sendTime: String? = null

    /** 过期时间 */
    @Column(name = "expire_time")
    var expireTime: String? = null

    /** 应用 id */
    @Column(name = "app_id")
    var appId: String? = null

    /** 用户 id */
    @Column(name = "user_id")
    var userId: String? = null

    /** 描述 */
    @Column(name = "exts")
    var exts: HashMap<String,Any?>? = null

    /** 未定义 */
    @Column(name = "int1")
    var int1: Int? = null

    /** 未定义 */
    @Column(name = "int2")
    var int2: Int? = null

    /** objType 对象类型 */
    @Column(name = "str1")
    var str1: String? = null

    /** classCode 分类 */
    @Column(name = "str2")
    var str2: String? = null

    /** 标记 1待处理 0处理完成 2处理失败 */
    @Column(name = "state")
    var state: Int? = null

    @Column(name = "count")
    var count: Int = 0

    /** 最后更新日期 */
    @Column(name = "last_update", updatable = false, insertable = false)
    var lastUpdate: Date? = null

    /** 创建时间 */
    @Column(name = "create_time", updatable = false, insertable = false)
    var createTime: Date? = null

} // Class SynchronousMessageObj