/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.models

/**
 * 中台信息点类
 *
 * @author  wx
 * @date  2020/9/20 9:39
 */
class DictPlatformInfo {

    /** id */
    var id: String? = null

    /** 类型编码 */
    var classCode: String? = null

    /** 动静分类:静态STATIC,脉冲PULSE,阶段GRADATION,时序SEQUENTIAL */
    var category: String? = null

    /** 信息点编码 */
    var code: String? = null

    /** 信息点名称 */
    var name: String? = null

    /** 分类:commo平台级, group集团级, project项目级 */
    var type: String? = null

    /** 集团id, 默认为"0" */
    var groupCode: String? = null

    /** 项目id, 默认为"0" */
    var projectId: String? = null

    /** 数据类型 */
    var dataType: String? = null

    /** 数据格式 */
    var formater: String? = null

    /** 数据格式 */
    var dataSource: ArrayList<Any?>? = null

    /** 输入方式 */
    var inputMode: String? = null

    /** 一级标签 */
    var firstTag: String? = null

    /** 二级标签 */
    var secondTag: String? = null

    /** 序列 */
    var idx: Int? = null

    /** 优先级,重要程度 */
    var priority: String? = null

    /** 单位 */
    var unit: String? = null

    /** 备注 */
    var note: String? = null

    /** 是否分类标签 */
    var canSub: Boolean? = null

    /** 是否复数 */
    var isMultiple: Boolean? = null

    /** 是否区间 */
    var isRegion: Boolean? = null

    /** 子分类标记 */
    var subFlag: Boolean? = null

    /** 是否只读, 如果是则不允许对该信息点做变更 */
    var readonly: Boolean? = null

    /** 旧字典编码 */
    var origCode: String? = null

    /** 旧字典编码类型 */
    var origDataType: String? = null

    /** 别编码 */
    var aliasCode: String? = null

    /** 别名称 */
    var aliasName: String? = null

} // Class DictPlatformInfo