/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.syn.models.tools

import com.persagy.base.extensions.toInt
import com.persagy.base.extensions.toJson
import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.wanda.obj.Equipment
import com.persagy.server.syn.Opts
import com.persagy.server.syn.models.tools.ProjectUtil
import com.persagy.service.SObjectService
import com.persagy.service.utils.SSpringContextUtil
import org.slf4j.LoggerFactory

/**
 * 设备数据转换工具
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/19 17:47
 */
object EquipUtil {
    /** 日志 */
    private val logger = LoggerFactory.getLogger(ProjectUtil::class.java)
    /** 信息点 */
    private val dictDefFuncIdService = SObjectService(SMybatisDao(DefFuncId::class.java))
    /** 配置 */
    private val opts: Opts by lazy {
        SSpringContextUtil.getBean(Opts::class.java) as Opts
    }

    /**
     * 设备转换
     */
//    fun equipSyn(projectId: String,groupCode: String, mapObj: HashMap<String, Any?>): Equipment {
//
//        /** 查建楼层型字典 */
//        val dictDefFuncIdList = dictDefFuncIdService.select(SFilter.eq("groupCode", groupCode), SFilter.eq("classCode", mapObj["classCode"].toString())).exec()
//        val mapEx = HashMap<String, Any?>()
//        val mapCode = HashMap<String, Any?>()
//
//        for (explainProject in dictDefFuncIdList) {
//            mapEx[explainProject.code!!] = explainProject.firstName
//            if (!explainProject.secondName.isNullOrEmpty()) {
//                mapCode[explainProject.code!!] = explainProject.secondName
//            }
//        }
//        /** 台账参数 */
//        val ledgerParamMap = HashMap<String, Any?>()
//        /** 通讯参数 */
//        val commParamMap = HashMap<String, Any?>()
//        /** 技术参数 */
//        val techParamMap = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamMap = HashMap<String, Any?>()
//        /** 设定参数 */
//        val settingParamMap = HashMap<String, Any?>()
//        /** 报警消息 */
//        val alramMap = HashMap<String, Any?>()
//        /** 自定义参数 */
//        val customParamMap = HashMap<String, Any?>()
//        /** 温度传感器 */
//        val tempSensor = HashMap<String, Any?>()
//        /** 技术参数-通用 */
//        val techParamGeneral = HashMap<String, Any?>()
//        /** 运行参数-通用 */
//        val runParamGeneral = HashMap<String, Any?>()
//        /** 速度传感器 */
//        val speedSensor = HashMap<String, Any?>()
//        /** 声音传感器 */
//        val soundSensor = HashMap<String, Any?>()
//        /** 湿度传感器 */
//        val humiditySensor = HashMap<String, Any?>()
//        /** 压力传感器 */
//        val pressTransd = HashMap<String, Any?>()
//        /** 热量传感器 */
//        val heatSensor = HashMap<String, Any?>()
//        /** 流量传感器 */
//        val flowSensor = HashMap<String, Any?>()
//        /** 电度传感器 */
//        val electricitySensor = HashMap<String, Any?>()
//        /** 位移传感器 */
//        val displSensor = HashMap<String, Any?>()
//        /** 浓度传感器 */
//        val concentSensor = HashMap<String, Any?>()
//        /** 图像传感器 */
//        val imageSensor = HashMap<String, Any?>()
//        /** 反馈参数 */
//        val feedbackParam = HashMap<String, Any?>()
//        /** 人流量传感器 */
//        val manFlowSensor = HashMap<String, Any?>()
//        /** 静态参数 */
//        val staticParam = HashMap<String,Any?>()
//
//        /** 图像传感器 **************************************************************************/
//        /** 技术参数 */
//        val techParamqpseyqoi = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqpseyqoi = HashMap<String, Any?>()
//
//
//        /** 浓度传感器 **************************************************************************/
//        /** 技术参数 */
//        val techParamqpseyqo = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqpseyqo = HashMap<String, Any?>()
//
//        /** 位移传感器 ********************************************************************/
//        /** 技术参数 */
//        val techParamqpseyq = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqpseyq = HashMap<String, Any?>()
//
//        /** 电度传感器 *******************************************************/
//        /** 技术参数 */
//        val techParamqpsey = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqpsey = HashMap<String, Any?>()
//
//        /** 流量传感器 ******************************************************/
//        /** 技术参数 */
//        val techParamqpse = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqpse = HashMap<String, Any?>()
//
//        /** 热量传感器 ********************************************************/
//        /** 技术参数 */
//        val techParamqps = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqps = HashMap<String, Any?>()
//
//        /** 压力传感器 **********************************/
//        /** 技术参数 */
//        val techParamqp = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoqp = HashMap<String, Any?>()
//
//        /** 湿度传感器 ***************************************/
//        /** 技术参数 */
//        val techParamq = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwoq = HashMap<String, Any?>()
//
//        /** 声音传感器 *******************************/
//        /** 技术参数-声音通用 */
//        val generalVoice = HashMap<String, Any?>()
//        /** 技术参数-噪声传感器 */
//        val noiseSensor = HashMap<String, Any?>()
//        /** 技术参数-录音 */
//        val soundRecording = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamer = HashMap<String, Any?>()
//
//        /** 速度传感器 ********************************************/
//        /** 技术参数 */
//        val techParam = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParamtwo = HashMap<String, Any?>()
//
//        /** 温度传感器 ***************************************/
//        /** 技术参数-温度通用 */
//        val tempGeneral = HashMap<String, Any?>()
//        /** 技术参数-热电偶温度传感器 */
//        val thermTemperSensor = HashMap<String, Any?>()
//        /** 技术参数-电阻温度传感器 */
//        val resisTempeSensor = HashMap<String, Any?>()
//        /** 技术参数-热敏电阻温度传感器 */
//        val thermTempeSensor = HashMap<String, Any?>()
//        /** 技术参数-IC温度传感器 */
//        val iCTempSensor = HashMap<String, Any?>()
//        /** 技术参数-玻璃管式温度计 */
//        val glassTubeTherm = HashMap<String, Any?>()
//        /** 技术参数-压力式温度计 */
//        val pressureThermo = HashMap<String, Any?>()
//        /** 技术参数-红外测温仪 */
//        val infraredTempInstru = HashMap<String, Any?>()
//        /** 运行参数 */
//        val runParam = HashMap<String, Any?>()
//        /** 技术参数 */
//        val techParamqpm = HashMap<String, Any?>()
//
//        /** 台账参数 ************************************************************/
//        /** 设备厂家 */
//        val equipManufactor = HashMap<String, Any?>()
//        /** 供应购买 */
//        val supplyPurchase = HashMap<String, Any?>()
//        /** 现场安装 */
//        val siteinstall = HashMap<String, Any?>()
//        /** 运行维保 */
//        val operationMainte = HashMap<String, Any?>()
//        /** 保险文件 */
//        val insuranceDoc = HashMap<String, Any?>()
//        /** 照片文档 */
//        val photoDoc = HashMap<String, Any?>()
//
//        /** 通讯参数 ********************************************************/
//        /** 协议 */
//        val agreement = HashMap<String, Any?>()
//        /** 通讯地址 */
//        val postalAddress = HashMap<String, Any?>()
//
//        /** 技术参数 ******************************************************************************/
//        /** 整机 */
//        val completeMachine = HashMap<String, Any?>()
//        /** 水泵 */
//        val waterPump = HashMap<String, Any?>()
//        /** 过滤器 */
//        val filter = HashMap<String, Any?>()
//        /** 施肥器 */
//        val fertiApplicator = HashMap<String, Any?>()
//        /** 接口 */
//        val interflicator = HashMap<String, Any?>()
//        /** 内胆 */
//        val internalBladder = HashMap<String, Any?>()
//        /** 保温层 */
//        val insulLayer = HashMap<String, Any?>()
//        /** 外壳 */
//        val shell = HashMap<String, Any?>()
//        /** 细格栅 */
//        val fineScreens = HashMap<String, Any?>()
//        /** 调节池 */
//        val regulatingPool = HashMap<String, Any?>()
//        /** 沉淀池 */
//        val sedimenTank = HashMap<String, Any?>()
//        /** 毛发过滤器 */
//        val hairFilter = HashMap<String, Any?>()
//        /** 加压泵 */
//        val pressPump = HashMap<String, Any?>()
//        /** 消毒设备 */
//        val disinfeEquip = HashMap<String, Any?>()
//        /** 膜处理系统 */
//        val membraneProcessingSystem = HashMap<String, Any?>()
//        /** 活性炭罐 */
//        val canister = HashMap<String, Any?>()
//        /** 中水回用池 */
//        val reclaWater = HashMap<String, Any?>()
//        /** 提升泵 */
//        val liftingPump = HashMap<String, Any?>()
//        /** 变频机组 */
//        val frequeUnit = HashMap<String, Any?>()
//        /** 无负压稳流机组 */
//        val pressureSteadyFlow = HashMap<String, Any?>()
//        /** 辅助设备 */
//        val auxiliaryEquip = HashMap<String, Any?>()
//        /** 紫外线发生器 */
//        val ultravGener = HashMap<String, Any?>()
//        /** 臭氧发生器 */
//        val ozoneGenerator = HashMap<String, Any?>()
//        /** 集热板 */
//        val collectorPlate = HashMap<String, Any?>()
//        /** 盖板 */
//        val coverPlate = HashMap<String, Any?>()
//        /** 性能 */
//        val performance = HashMap<String, Any?>()
//        /** 电加热 */
//        val electricHeating = HashMap<String, Any?>()
//        /** 换热器 */
//        val heatExcha = HashMap<String, Any?>()
//        /** 热水锅炉 */
//        val hotWaterBoiler = HashMap<String, Any?>()
//        /** 蒸汽锅炉 */
//        val steamBoiler = HashMap<String, Any?>()
//        /** 烟气余热回收装置 */
//        val flueGasWasteHeat = HashMap<String, Any?>()
//        /** 蒸汽冷凝水回收装置 */
//        val steamConde = HashMap<String, Any?>()
//        /** 制冷工况 */
//        val refrigCondition = HashMap<String, Any?>()
//        /** 制热工况 */
//        val heatingCondi = HashMap<String, Any?>()
//        /** 软化器 */
//        val softener = HashMap<String, Any?>()
//        /** 反渗透 */
//        val reverseOsmosis = HashMap<String, Any?>()
//        /** 储水箱 */
//        val waterStoragetank = HashMap<String, Any?>()
//        /** 紫外线杀菌器 */
//        val ultravSteri = HashMap<String, Any?>()
//        /** 消毒剂 */
//        val disinf = HashMap<String, Any?>()
//        /** 加热器 */
//        val heater = HashMap<String, Any?>()
//        /** 高频头 */
//        val tuner = HashMap<String, Any?>()
//        /** 接收器 */
//        val receiver = HashMap<String, Any?>()
//        /** 混合器 */
//        val mixer = HashMap<String, Any?>()
//        /** 监视器 */
//        val monitor = HashMap<String, Any?>()
//        /** 功放 */
//        val powerAmpli = HashMap<String, Any?>()
//        /** 调制器 */
//        val modulator = HashMap<String, Any?>()
//        /** 分支分配器 */
//        val branchDis = HashMap<String, Any?>()
//        /** 光端机 */
//        val opticalTerminal = HashMap<String, Any?>()
//        /** 播放器 */
//        val player = HashMap<String, Any?>()
//        /** 显示屏 */
//        val display = HashMap<String, Any?>()
//        /** IC读卡机 */
//        val iCCardReader = HashMap<String, Any?>()
//        /** 密码键盘 */
//        val passwordKeyb = HashMap<String, Any?>()
//        /** 身份证阅读器 */
//        val iDCardReader = HashMap<String, Any?>()
//        /** 打印机 */
//        val printer = HashMap<String, Any?>()
//        /** 指纹识别仪 */
//        val fingerIdent = HashMap<String, Any?>()
//        /** 摄像头 */
//        val camera = HashMap<String, Any?>()
//        /** 其他设备 */
//        val otherEquip = HashMap<String, Any?>()
//        /** 通用电气指标 */
//        val generalElecIndex = HashMap<String, Any?>()
//        /** 空间辐射指标 */
//        val spatialRadiIndex = HashMap<String, Any?>()
//        /** 无线模块 */
//        val wirelessModule = HashMap<String, Any?>()
//        /** 发射指标 */
//        val launchIndex = HashMap<String, Any?>()
//        /** 接收指标 */
//        val receiIndex = HashMap<String, Any?>()
//        /** 视频式 */
//        val videoType = HashMap<String, Any?>()
//        /** 红外探测器 */
//        val infraredDetector = HashMap<String, Any?>()
//        /** 玻璃破碎探测器 */
//        val glassCrushDetec = HashMap<String, Any?>()
//        /** 电动机 */
//        val motor = HashMap<String, Any?>()
//        /** 制动器 */
//        val brake = HashMap<String, Any?>()
//        /** 减速器 */
//        val retarder = HashMap<String, Any?>()
//        /** 联轴器 */
//        val coupling = HashMap<String, Any?>()
//        /** 发电机组 */
//        val generatorSet = HashMap<String, Any?>()
//        /** 柴油机 */
//        val dieselEngine = HashMap<String, Any?>()
//        /** 总体 */
//        val population = HashMap<String, Any?>()
//        /** 输入 */
//        val input = HashMap<String, Any?>()
//        /** 输出 */
//        val output = HashMap<String, Any?>()
//        /** 电池 */
//        val battery = HashMap<String, Any?>()
//        /** 负荷开关 */
//        val loadSwitch = HashMap<String, Any?>()
//        /** 熔断器 */
//        val fuse = HashMap<String, Any?>()
//        /** 隔离/接地开关 */
//        val earthingSwitch = HashMap<String, Any?>()
//        /** 低压断路器（空气开关） */
//        val lowBreaker = HashMap<String, Any?>()
//        /** 电压互感器 */
//        val voltageTrans = HashMap<String, Any?>()
//        /** 电流互感器 */
//        val currentTrans = HashMap<String, Any?>()
//        /** 接触器 */
//        val contactor = HashMap<String, Any?>()
//        /** 漏电保护器 */
//        val leakageProtector = HashMap<String, Any?>()
//        /** 继电器 */
//        val relay = HashMap<String, Any?>()
//        /** 接线端子 */
//        val connectionTerminal = HashMap<String, Any?>()
//        /** 开关保护 */
//        val switchProte = HashMap<String, Any?>()
//        /** 断路器 */
//        val circuitBreaker = HashMap<String, Any?>()
//        /** 保温材料 */
//        val thermalInsulMaterial = HashMap<String, Any?>()
//        /** 塑料管 */
//        val plasticPipe = HashMap<String, Any?>()
//        /** 矩形风管 */
//        val rectDuct = HashMap<String, Any?>()
//        /** 圆形风管 */
//        val circularDuct = HashMap<String, Any?>()
//        /** 扁圆形风管 */
//        val flatCircularDuct = HashMap<String, Any?>()
//        /** 通用 */
//        val currency = HashMap<String, Any?>()
//        /** 安全阀 */
//        val safetyValve = HashMap<String, Any?>()
//        /** 减压阀 */
//        val pressRreliefValve = HashMap<String, Any?>()
//        /** 线圈 */
//        val coil = HashMap<String, Any?>()
//        /** 触点 */
//        val contact = HashMap<String, Any?>()
//        /** 通断阀 */
//        val onOffValve = HashMap<String, Any?>()
//        /** 止回阀 */
//        val checkValve = HashMap<String, Any?>()
//        /** 调节阀 */
//        val regulValve = HashMap<String, Any?>()
//        /** 泡沫灭火器 */
//        val foamExtinguisher = HashMap<String, Any?>()
//        /** 干粉灭火器 */
//        val dryPowderExti = HashMap<String, Any?>()
//        /** 二氧化碳灭火器 */
//        val carbonExting = HashMap<String, Any?>()
//        /** 卤代烷灭火器 */
//        val halogAgentExting = HashMap<String, Any?>()
//        /** 清水灭火器 */
//        val cleanWaterExting = HashMap<String, Any?>()
//        /** 主机 */
//        val host = HashMap<String, Any?>()
//        /** 前置功放 */
//        val preamplifier = HashMap<String, Any?>()
//        /** 矩阵 */
//        val matrix = HashMap<String, Any?>()
//        /** CD录放盘 */
//        val cdRecording = HashMap<String, Any?>()
//        /** 龙骨 */
//        val keel = HashMap<String, Any?>()
//        /** 嵌板 */
//        val panel = HashMap<String, Any?>()
//        /** 组件 */
//        val assembly = HashMap<String, Any?>()
//        /** 压缩机 */
//        val compressor = HashMap<String, Any?>()
//        /** 蒸发器 */
//        val evaporator = HashMap<String, Any?>()
//        /** 节流元件 */
//        val throtElement = HashMap<String, Any?>()
//        /** 冷凝器 */
//        val condenser = HashMap<String, Any?>()
//        /** 发生器 */
//        val generator = HashMap<String, Any?>()
//        /** 吸收器 */
//        val absorber = HashMap<String, Any?>()
//        /** 风机 */
//        val fan = HashMap<String, Any?>()
//        /** 过滤段 */
//        val filterSegment = HashMap<String, Any?>()
//        /** 热回收段 */
//        val heatRecoverySection = HashMap<String, Any?>()
//        /** 表冷段 */
//        val surfaceCoolSection = HashMap<String, Any?>()
//        /** 加湿段 */
//        val humidSection = HashMap<String, Any?>()
//        /** 再热段 */
//        val reheaSection = HashMap<String, Any?>()
//        /** 送风段 */
//        val airSupply = HashMap<String, Any?>()
//        /** 水地暖设备 */
//        val waterHeatingEquip = HashMap<String, Any?>()
//        /** 碳晶地暖设备 */
//        val carCryGroHeatEquip = HashMap<String, Any?>()
//        /** 发热电缆设备 */
//        val thermCableEquip = HashMap<String, Any?>()
//        /** 盘管 */
//        val conduit = HashMap<String, Any?>()
//        /** 新风段 */
//        val freshAir = HashMap<String, Any?>()
//        /** 混风段 */
//        val mixingSection = HashMap<String, Any?>()
//        /** 其他 */
//        val other = HashMap<String, Any?>()
//
//
//        /** 运行参数 ******************************************************/
//        /** 瞬时状态 */
//        val instanState = HashMap<String, Any?>()
//        /** 累计指标 */
//        val cumulaIndex = HashMap<String, Any?>()
//        /** 出口水质 */
//        val exportWaterQuality = HashMap<String, Any?>()
//        /** CPU状态 */
//        val cpuStates = HashMap<String, Any?>()
//        /** 关键指标 */
//        val keyIndic = HashMap<String, Any?>()
//        /** 开关状态 */
//        val switchingState = HashMap<String, Any?>()
//        /** 电压 */
//        val voltage = HashMap<String, Any?>()
//        /** 电流 */
//        val electricCurrent = HashMap<String, Any?>()
//        /** 功率 */
//        val power = HashMap<String, Any?>()
//        /** 总谐波 */
//        val totalHarmonic = HashMap<String, Any?>()
//        /** 畸变率 */
//        val distortRate = HashMap<String, Any?>()
//        /** 累计参数 */
//        val cumuParam = HashMap<String, Any?>()
//        /** 保护 */
//        val protect = HashMap<String, Any?>()
//        /** 瞬时指标 */
//        val instanIndex = HashMap<String, Any?>()
//        /** 水侧 */
//        val waterSide = HashMap<String, Any?>()
//        /** 空气侧 */
//        val airSide = HashMap<String, Any?>()
//        /** 塔盘水位 */
//        val trayWater = HashMap<String, Any?>()
//        /** 风机 */
//        val fans = HashMap<String, Any?>()
//        /** 盘管 */
//        val conduits = HashMap<String, Any?>()
//
//        /** 人流量传感器 */
//        /** 运行参数 */
//        val runParamMan = HashMap<String, Any?>()
//        /** 技术参数 */
//        val techParamqpMam = HashMap<String, Any?>()
//
//        val equipment = Equipment()
//        equipment.projectId = projectId
//        equipment.classCode = mapObj["classCode"].toString()
//        /** id 是否存在 */
//        val containsKeyId = mapObj.containsKey("id")
//        if(containsKeyId){
//            equipment.id = mapObj["id"].toString()
//        }
//        /** name 是否存在 */
//        val containsKeyName = mapObj.containsKey("name")
//        if(containsKeyName){
//            equipment.name = mapObj["name"].toString()
//        }
//
//        for (key in mapObj!!.keys) {
//            /** 判断key是否存在 */
//            val containsKey = mapEx.containsKey(key)
//            if (containsKey) {
//                val value = mapEx[key]
//                if (value == opts.LedgerParam) {
//                    /** 台账参数 */
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "设备厂家") {
//
//                            if (key == "testReport"){
//                                /** 检测报告 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        equipManufactor[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if (key == "originalCertificate"){
//                                /** 原厂证明 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        equipManufactor[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else {
//                                equipManufactor[key] = mapObj[key]
//                            }
//                        } else if (any == "供应购买") {
//
//                            if (key == "acceptanceReport"){
//                                /** 验收报告 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        supplyPurchase[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//
//                            }else if (key == "approachingAcceptance"){
//                                /** 进场验收单 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        supplyPurchase[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//
//                            }else if (key == "supplierContract"){
//                                /** 供应合同 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        supplyPurchase[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else{
//                                supplyPurchase[key] = mapObj[key]
//                            }
//
//                        } else if (any == "现场安装") {
//                            /** 安装图纸 安装照片 安装质检报告 */
//                            if (key == "installDrawing" ){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        siteinstall[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if (key == "installPic"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        siteinstall[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if (key == "checkReport"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        siteinstall[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if (key == "installInstruction"){
//                                /** 安装说明书 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        siteinstall[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else{
//                                siteinstall[key] = mapObj[key]
//                            }
//
//                        } else if (any == "运行维保") {
//
//                            if (key == "maintainManual"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        operationMainte[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else{
//                                operationMainte[key] = mapObj[key]
//                            }
//                        } else if (any == "保险文件") {
//                            /** 保险文件 */
//                            if (key == "insuranceFile"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        insuranceDoc[key] = listPic.toJson()
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else{
//                                insuranceDoc[key] = mapObj[key]
//                            }
//
//                        } else if (any == "照片文档") {
//                            /** 设备铭牌照片 设备照片 设备图纸 设备文档 */
//                            if (key == "nameplate"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if (key == "pic"){
//                                try {
//                                    logger.debug("图片：${mapObj[key].toString()}")
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if(key == "drawing"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
////                                    val attPicList = SJsonUtil.fromJson<ArrayList<AttPic>>(infosMap[key].toString())
//                                    if (attPicList.isNotEmpty()){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                }
//                            }else if(key == "archive"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                    photoDoc[key] = ArrayList<Any>()
//                                }
//                            }else if(key == "operationManual"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                    photoDoc[key] = ArrayList<Any>()
//                                }
//                            }else if (key == "productCertification"){
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                    photoDoc[key] = ArrayList<Any>()
//                                }
//                            }else if (key == "operationManual"){
//                                /** 操作说明书 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                    photoDoc[key] = ArrayList<Any>()
//                                }
//                            }else if (key == "productCertification"){
//                                /** 产品合格证 */
//                                try {
//                                    val gson = Gson()
//                                    val type = object : TypeToken<ArrayList<AttPic>>() {
//                                    }.type
//                                    val attPicList = gson.fromJson<ArrayList<AttPic>>(mapObj[key].toString(),type)
//                                    if (attPicList.isNotEmpty()&&attPicList.size>0){
//                                        val listPic =ArrayList<TaskPic>()
//                                        for (attPic in attPicList){
//                                            val taskPic = TaskPic()
//                                            taskPic.key = attPic.key
//                                            taskPic.name = attPic.name
//                                            taskPic.systemId = attPic.systemId
//                                            taskPic.type = attPic.type
//                                            taskPic.createTime = attPic.createTime
//                                            listPic.add(taskPic)
//                                        }
//                                        photoDoc[key] = listPic
//                                    }
//                                } catch (e: Exception) {
//                                    e.printStackTrace()
//                                    photoDoc[key] = ArrayList<Any>()
//                                }
//                            }else{
//                                photoDoc[key] = mapObj[key]
//                            }
//                        } else {
//                            ledgerParamMap[key] = mapObj[key]
//                        }
//                    } else {
//                        ledgerParamMap[key] = mapObj[key]
//                    }
//                } else if (value == opts.CommParam) {
//                    /** 通讯参数 */
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "协议") {
//                            agreement[key] = mapObj[key]
//                        } else if (any == "通讯地址") {
//                            postalAddress[key] = mapObj[key]
//                        } else {
//                            commParamMap[key] = mapObj[key]
//                        }
//                    } else {
//                        commParamMap[key] = mapObj[key]
//                    }
//                } else if (value == opts.TechParam) {
//                    /** 技术参数 */
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "整机") {
//                            completeMachine[key] = mapObj[key]
//                        } else if (any == "水泵") {
//                            waterPump[key] = mapObj[key]
//                        } else if (any == "过滤器") {
//                            filter[key] = mapObj[key]
//                        } else if (any == "施肥器") {
//                            fertiApplicator[key] = mapObj[key]
//                        } else if (any == "接口") {
//                            interflicator[key] = mapObj[key]
//                        } else if (any == "内胆") {
//                            internalBladder[key] = mapObj[key]
//                        } else if (any == "保温层") {
//                            insulLayer[key] = mapObj[key]
//                        } else if (any == "外壳") {
//                            shell[key] = mapObj[key]
//                        } else if (any == "细格栅") {
//                            fineScreens[key] = mapObj[key]
//                        } else if (any == "调节池") {
//                            regulatingPool[key] = mapObj[key]
//                        } else if (any == "沉淀池") {
//                            sedimenTank[key] = mapObj[key]
//                        } else if (any == "毛发过滤器") {
//                            hairFilter[key] = mapObj[key]
//                        } else if (any == "加压泵") {
//                            pressPump[key] = mapObj[key]
//                        } else if (any == "消毒设备") {
//                            disinfeEquip[key] = mapObj[key]
//                        } else if (any == "膜处理系统") {
//                            membraneProcessingSystem[key] = mapObj[key]
//                        } else if (any == "活性炭罐") {
//                            canister[key] = mapObj[key]
//                        } else if (any == "中水回用池") {
//                            reclaWater[key] = mapObj[key]
//                        } else if (any == "提升泵") {
//                            liftingPump[key] = mapObj[key]
//                        } else if (any == "变频机组") {
//                            frequeUnit[key] = mapObj[key]
//                        } else if (any == "无负压稳流机组") {
//                            pressureSteadyFlow[key] = mapObj[key]
//                        } else if (any == "辅助设备") {
//                            auxiliaryEquip[key] = mapObj[key]
//                        } else if (any == "紫外线发生器") {
//                            ultravGener[key] = mapObj[key]
//                        } else if (any == "臭氧发生器") {
//                            ozoneGenerator[key] = mapObj[key]
//                        } else if (any == "集热板") {
//                            collectorPlate[key] = mapObj[key]
//                        } else if (any == "盖板") {
//                            coverPlate[key] = mapObj[key]
//                        } else if (any == "性能") {
//                            performance[key] = mapObj[key]
//                        } else if (any == "电加热") {
//                            electricHeating[key] = mapObj[key]
//                        } else if (any == "换热器") {
//                            heatExcha[key] = mapObj[key]
//                        } else if (any == "热水锅炉") {
//                            hotWaterBoiler[key] = mapObj[key]
//                        } else if (any == "蒸汽锅炉") {
//                            steamBoiler[key] = mapObj[key]
//                        } else if (any == "烟气余热回收装置") {
//                            flueGasWasteHeat[key] = mapObj[key]
//                        } else if (any == "蒸汽冷凝水回收装置") {
//                            steamConde[key] = mapObj[key]
//                        } else if (any == "制冷工况") {
//                            refrigCondition[key] = mapObj[key]
//                        } else if (any == "制热工况") {
//                            heatingCondi[key] = mapObj[key]
//                        } else if (any == "软化器") {
//                            softener[key] = mapObj[key]
//                        } else if (any == "反渗透") {
//                            reverseOsmosis[key] = mapObj[key]
//                        } else if (any == "储水箱") {
//                            waterStoragetank[key] = mapObj[key]
//                        } else if (any == "紫外线杀菌器") {
//                            ultravSteri[key] = mapObj[key]
//                        } else if (any == "消毒剂") {
//                            disinf[key] = mapObj[key]
//                        } else if (any == "加热器") {
//                            heater[key] = mapObj[key]
//                        } else if (any == "高频头") {
//                            tuner[key] = mapObj[key]
//                        } else if (any == "接收器") {
//                            receiver[key] = mapObj[key]
//                        } else if (any == "混合器") {
//                            mixer[key] = mapObj[key]
//                        } else if (any == "监视器") {
//                            monitor[key] = mapObj[key]
//                        } else if (any == "功放") {
//                            powerAmpli[key] = mapObj[key]
//                        } else if (any == "调制器") {
//                            modulator[key] = mapObj[key]
//                        } else if (any == "分支分配器") {
//                            branchDis[key] = mapObj[key]
//                        } else if (any == "光端机") {
//                            opticalTerminal[key] = mapObj[key]
//                        } else if (any == "播放器") {
//                            player[key] = mapObj[key]
//                        } else if (any == "显示屏") {
//                            display[key] = mapObj[key]
//                        } else if (any == "IC读卡机") {
//                            iCCardReader[key] = mapObj[key]
//                        } else if (any == "密码键盘") {
//                            passwordKeyb[key] = mapObj[key]
//                        } else if (any == "身份证阅读器") {
//                            iDCardReader[key] = mapObj[key]
//                        } else if (any == "打印机") {
//                            printer[key] = mapObj[key]
//                        } else if (any == "指纹识别仪") {
//                            fingerIdent[key] = mapObj[key]
//                        } else if (any == "摄像头") {
//                            camera[key] = mapObj[key]
//                        } else if (any == "其他设备") {
//                            otherEquip[key] = mapObj[key]
//                        } else if (any == "通用电气指标") {
//                            generalElecIndex[key] = mapObj[key]
//                        } else if (any == "空间辐射指标") {
//                            spatialRadiIndex[key] = mapObj[key]
//                        } else if (any == "无线模块") {
//                            wirelessModule[key] = mapObj[key]
//                        } else if (any == "发射指标") {
//                            launchIndex[key] = mapObj[key]
//                        } else if (any == "接收指标") {
//                            receiIndex[key] = mapObj[key]
//                        } else if (any == "视频式") {
//                            videoType[key] = mapObj[key]
//                        } else if (any == "红外探测器") {
//                            infraredDetector[key] = mapObj[key]
//                        } else if (any == "玻璃破碎探测器") {
//                            glassCrushDetec[key] = mapObj[key]
//                        } else if (any == "电动机") {
//                            motor[key] = mapObj[key]
//                        } else if (any == "制动器") {
//                            brake[key] = mapObj[key]
//                        } else if (any == "减速器") {
//                            retarder[key] = mapObj[key]
//                        } else if (any == "联轴器") {
//                            coupling[key] = mapObj[key]
//                        } else if (any == "发电机组") {
//                            generatorSet[key] = mapObj[key]
//                        } else if (any == "柴油机") {
//                            dieselEngine[key] = mapObj[key]
//                        } else if (any == "总体") {
//                            population[key] = mapObj[key]
//                        } else if (any == "输入") {
//                            input[key] = mapObj[key]
//                        } else if (any == "输出") {
//                            output[key] = mapObj[key]
//                        } else if (any == "电池") {
//                            battery[key] = mapObj[key]
//                        } else if (any == "负荷开关") {
//                            loadSwitch[key] = mapObj[key]
//                        } else if (any == "熔断器") {
//                            fuse[key] = mapObj[key]
//                        } else if (any == "隔离/接地开关") {
//                            earthingSwitch[key] = mapObj[key]
//                        } else if (any == "低压断路器（空气开关）") {
//                            lowBreaker[key] = mapObj[key]
//                        } else if (any == "电压互感器") {
//                            voltageTrans[key] = mapObj[key]
//                        } else if (any == "电流互感器") {
//                            currentTrans[key] = mapObj[key]
//                        } else if (any == "接触器") {
//                            contactor[key] = mapObj[key]
//                        } else if (any == "漏电保护器") {
//                            leakageProtector[key] = mapObj[key]
//                        } else if (any == "继电器") {
//                            relay[key] = mapObj[key]
//                        } else if (any == "接线端子") {
//                            connectionTerminal[key] = mapObj[key]
//                        } else if (any == "开关保护") {
//                            switchProte[key] = mapObj[key]
//                        } else if (any == "断路器") {
//                            circuitBreaker[key] = mapObj[key]
//                        } else if (any == "保温材料") {
//                            thermalInsulMaterial[key] = mapObj[key]
//                        } else if (any == "塑料管") {
//                            plasticPipe[key] = mapObj[key]
//                        } else if (any == "矩形风管") {
//                            rectDuct[key] = mapObj[key]
//                        } else if (any == "圆形风管") {
//                            circularDuct[key] = mapObj[key]
//                        } else if (any == "扁圆形风管") {
//                            flatCircularDuct[key] = mapObj[key]
//                        } else if (any == "通用") {
//                            currency[key] = mapObj[key]
//                        } else if (any == "安全阀") {
//                            safetyValve[key] = mapObj[key]
//                        } else if (any == "减压阀") {
//                            pressRreliefValve[key] = mapObj[key]
//                        } else if (any == "线圈") {
//                            coil[key] = mapObj[key]
//                        } else if (any == "触点") {
//                            contact[key] = mapObj[key]
//                        } else if (any == "通断阀") {
//                            onOffValve[key] = mapObj[key]
//                        } else if (any == "止回阀") {
//                            checkValve[key] = mapObj[key]
//                        } else if (any == "调节阀") {
//                            regulValve[key] = mapObj[key]
//                        } else if (any == "泡沫灭火器") {
//                            foamExtinguisher[key] = mapObj[key]
//                        } else if (any == "干粉灭火器") {
//                            dryPowderExti[key] = mapObj[key]
//                        } else if (any == "二氧化碳灭火器") {
//                            carbonExting[key] = mapObj[key]
//                        } else if (any == "卤代烷灭火器") {
//                            halogAgentExting[key] = mapObj[key]
//                        } else if (any == "清水灭火器") {
//                            cleanWaterExting[key] = mapObj[key]
//                        } else if (any == "主机") {
//                            host[key] = mapObj[key]
//                        } else if (any == "前置功放") {
//                            preamplifier[key] = mapObj[key]
//                        } else if (any == "矩阵") {
//                            matrix[key] = mapObj[key]
//                        } else if (any == "CD录放盘") {
//                            cdRecording[key] = mapObj[key]
//                        } else if (any == "龙骨") {
//                            keel[key] = mapObj[key]
//                        } else if (any == "嵌板") {
//                            panel[key] = mapObj[key]
//                        } else if (any == "组件") {
//                            assembly[key] = mapObj[key]
//                        } else if (any == "压缩机") {
//                            compressor[key] = mapObj[key]
//                        } else if (any == "蒸发器") {
//                            evaporator[key] = mapObj[key]
//                        } else if (any == "节流元件") {
//                            throtElement[key] = mapObj[key]
//                        } else if (any == "冷凝器") {
//                            condenser[key] = mapObj[key]
//                        } else if (any == "发生器") {
//                            generator[key] = mapObj[key]
//                        } else if (any == "吸收器") {
//                            absorber[key] = mapObj[key]
//                        } else if (any == "风机") {
//                            fan[key] = mapObj[key]
//                        } else if (any == "过滤段") {
//                            filterSegment[key] = mapObj[key]
//                        } else if (any == "热回收段") {
//                            heatRecoverySection[key] = mapObj[key]
//                        } else if (any == "表冷段") {
//                            surfaceCoolSection[key] = mapObj[key]
//                        } else if (any == "加湿段") {
//                            humidSection[key] = mapObj[key]
//                        } else if (any == "再热段") {
//                            reheaSection[key] = mapObj[key]
//                        } else if (any == "送风段") {
//                            airSupply[key] = mapObj[key]
//                        } else if (any == "水地暖设备") {
//                            waterHeatingEquip[key] = mapObj[key]
//                        } else if (any == "碳晶地暖设备") {
//                            carCryGroHeatEquip[key] = mapObj[key]
//                        } else if (any == "发热电缆设备") {
//                            thermCableEquip[key] = mapObj[key]
//                        } else if (any == "盘管") {
//                            conduit[key] = mapObj[key]
//                        } else if (any == "新风段") {
//                            freshAir[key] = mapObj[key]
//                        } else if (any == "混风段") {
//                            mixingSection[key] = mapObj[key]
//                        } else if (any == "其他") {
//                            other[key] = mapObj[key]
//                        } else {
//                            techParamMap[key] = mapObj[key]
//                        }
//                    } else {
//                        techParamMap[key] = mapObj[key]
//                    }
////                                techParamMap[key] = infosMap[key]
//                } else if (value == opts.RunParam) {
//                    /** 运行参数 */
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "瞬时状态") {
//                            instanState[key] = mapObj[key]
//                        } else if (any == "累计指标") {
//                            cumulaIndex[key] = mapObj[key]
//                        } else if (any == "出口水质") {
//                            exportWaterQuality[key] = mapObj[key]
//                        } else if (any == "CPU状态") {
//                            cpuStates[key] = mapObj[key]
//                        } else if (any == "关键指标") {
//                            keyIndic[key] = mapObj[key]
//                        } else if (any == "开关状态") {
//                            switchingState[key] = mapObj[key]
//                        } else if (any == "电压") {
//                            voltage[key] = mapObj[key]
//                        } else if (any == "电流") {
//                            electricCurrent[key] = mapObj[key]
//                        } else if (any == "功率") {
//                            power[key] = mapObj[key]
//                        } else if (any == "总谐波") {
//                            totalHarmonic[key] = mapObj[key]
//                        } else if (any == "畸变率") {
//                            distortRate[key] = mapObj[key]
//                        } else if (any == "累计参数") {
//                            cumuParam[key] = mapObj[key]
//                        } else if (any == "保护") {
//                            protect[key] = mapObj[key]
//                        } else if (any == "瞬时指标") {
//                            instanIndex[key] = mapObj[key]
//                        } else if (any == "水侧") {
//                            waterSide[key] = mapObj[key]
//                        } else if (any == "空气侧") {
//                            airSide[key] = mapObj[key]
//                        } else if (any == "塔盘水位") {
//                            trayWater[key] = mapObj[key]
//                        } else if (any == "风机") {
//                            fans[key] = mapObj[key]
//                        } else if (any == "盘管") {
//                            conduits[key] = mapObj[key]
//                        } else {
//                            runParamMap[key] = mapObj[key]
//                        }
//                    } else {
//                        runParamMap[key] = mapObj[key]
//                    }
////                                runParamMap[key] = infosMap[key]
//                } else if (value == opts.SettingParam) {
//                    /** 设定参数 */
//                    settingParamMap[key] = mapObj[key]
//                } else if (value == opts.Alram) {
//                    /** 报警消息 */
//                    alramMap[key] = mapObj[key]
//                } else if (value == "温度传感器") {
//
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数-温度通用") {
//                            tempGeneral[key] = mapObj[key]
//                        } else if (any == "技术参数-热电偶温度传感器") {
//                            thermTemperSensor[key] = mapObj[key]
//                        } else if (any == "技术参数-电阻温度传感器") {
//                            resisTempeSensor[key] = mapObj[key]
//                        } else if (any == "技术参数-热敏电阻温度传感器") {
//                            thermTempeSensor[key] = mapObj[key]
//                        } else if (any == "技术参数-IC温度传感器") {
//                            iCTempSensor[key] = mapObj[key]
//                        } else if (any == "技术参数-玻璃管式温度计") {
//                            glassTubeTherm[key] = mapObj[key]
//                        } else if (any == "技术参数-压力式温度计") {
//                            pressureThermo[key] = mapObj[key]
//                        } else if (any == "技术参数-红外测温仪") {
//                            infraredTempInstru[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParam[key] = mapObj[key]
//                        } else if (any == "技术参数") {
//                            techParamqpm[key] = mapObj[key]
//                        } else {
//                            tempSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        tempSensor[key] = mapObj[key]
//                    }
//                } else if (value == "技术参数-通用") {
//
//                    techParamGeneral[key] = mapObj[key]
//
//                } else if (value == "运行参数-通用") {
//                    runParamGeneral[key] = mapObj[key]
//
//                } else if (value == "速度传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParam[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwo[key] = mapObj[key]
//                        } else {
//                            speedSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        speedSensor[key] = mapObj[key]
//                    }
//                } else if (value == "声音传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数-声音通用") {
//                            generalVoice[key] = mapObj[key]
//                        } else if (any == "技术参数-噪声传感器") {
//                            noiseSensor[key] = mapObj[key]
//                        } else if (any == "技术参数-录音") {
//                            soundRecording[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamer[key] = mapObj[key]
//                        } else {
//                            soundSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        soundSensor[key] = mapObj[key]
//                    }
//                } else if (value == "湿度传感器") {
////                    logger.debug("湿度传感器：key:${key},${ mapObj[key]}")
////                    logger.debug("湿度传感器1：${mapCode[key].toString()}")
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamq[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoq[key] = mapObj[key]
//                        } else {
//                            humiditySensor[key] = mapObj[key]
//                        }
//                    } else {
//                        humiditySensor[key] = mapObj[key]
//                    }
//                } else if (value == "压力传感器") {
//
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqp[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqp[key] = mapObj[key]
//                        } else {
//                            pressTransd[key] = mapObj[key]
//                        }
//                    } else {
//                        pressTransd[key] = mapObj[key]
//                    }
//                } else if (value == "热量传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqps[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqps[key] = mapObj[key]
//                        } else {
//                            heatSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        heatSensor[key] = mapObj[key]
//                    }
//                } else if (value == "流量传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpse[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqpse[key] = mapObj[key]
//                        } else {
//                            flowSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        flowSensor[key] = mapObj[key]
//                    }
//                } else if (value == "电度传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpsey[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqpsey[key] = mapObj[key]
//                        } else {
//                            electricitySensor[key] = mapObj[key]
//                        }
//                    } else {
//                        electricitySensor[key] = mapObj[key]
//                    }
//                } else if (value == "位移传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpseyq[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqpseyq[key] = mapObj[key]
//                        } else {
//                            displSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        displSensor[key] = mapObj[key]
//                    }
//
//                } else if (value == "浓度传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpseyqo[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqpseyqo[key] = mapObj[key]
//                        } else {
//                            concentSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        concentSensor[key] = mapObj[key]
//                    }
//                } else if (value == "图像传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpseyqoi[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamtwoqpseyqoi[key] = mapObj[key]
//                        } else {
//                            imageSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        imageSensor[key] = mapObj[key]
//                    }
//                } else if (value == "人流量传感器") {
//                    val contains = mapCode.containsKey(key)
//                    if (contains) {
//                        val any = mapCode[key].toString()
//                        if (any == "技术参数") {
//                            techParamqpMam[key] = mapObj[key]
//                        } else if (any == "运行参数") {
//                            runParamMan[key] = mapObj[key]
//                        } else {
//                            manFlowSensor[key] = mapObj[key]
//                        }
//                    } else {
//                        manFlowSensor[key] = mapObj[key]
//                    }
//                } else if (key.startsWith("ctm-")) {
//                    customParamMap[key] = mapObj[key]
//                } else if (value == "反馈参数") {
//                    feedbackParam[key] = mapObj[key]
//                } else if (value == "静态参数") {
//                    staticParam[key] = mapObj[key]
//                } else {
//                    if (key == "localId") {
//                        equipment.localId = mapObj[key].toString()
//                    } else if (key == "localName") {
//                        equipment.localName = mapObj[key].toString()
//                    } else if (key == "qRCodePic") {
//                        equipment.qRCodePic = mapObj[key].toString()
//                    }  else if (key == "cadId") {
//                        equipment.cadId = mapObj[key].toString()
//                    } else if (key == "bimId") {
//                        equipment.bimId = mapObj[key].toString()
//                    } else if (key == "bimLocation") {
//                        equipment.bimLocation = mapObj[key].toString()
//                    } else if (key == "DPManufacturerID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpManufacturerID = mapObj[key].toString()
//                        }
//                    } else if (key == "DPSupplierID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpSupplierID = mapObj[key].toString()
//                        }
//                    } else if (key == "DPMaintainerID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpMaintainerID = mapObj[key].toString()
//                        }
//                    } else if (key == "DPInsurerID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpInsurerID = mapObj[key].toString()
//                        }
//                    } else if (key == "DPSpecificationID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpSpecificationID = mapObj[key].toString()
//                        }
//                    } else if (key == "DPBrandID") {
//                        if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                            equipment.dpBrandID = mapObj[key].toString()
//                        }
//                    }else if (key == "bimFamilyName"){
//                        equipment.bimFamilyName = mapObj[key].toString()
//                    }else if(key == "bimFamilySymbol"){
//                        equipment.bimFamilySymbol = mapObj[key].toString()
//                    }else if (key == "rfId"){
//                        equipment.rfId = mapObj[key].toString()
//                    }else if (key == "bimTypeId"){
//                        equipment.bimTypeId = mapObj[key].toString()
//                    }else if (key == "equipSerial"){
//                        equipment.equipSerial = mapObj[key].toString().toDouble()
//                    }
//                }
//            } else if (key.startsWith("ctm-")) {
//                customParamMap[key] = mapObj[key]
//            } else {
//                if (key == "DPManufacturerID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpManufacturerID = mapObj[key].toString()
//                    }
//
//                } else if (key == "DPSupplierID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpSupplierID = mapObj[key].toString()
//                    }
//
//                } else if (key == "DPMaintainerID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpMaintainerID = mapObj[key].toString()
//                    }
//
//                } else if (key == "DPInsurerID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpInsurerID = mapObj[key].toString()
//                    }
//
//                } else if (key == "DPSpecificationID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpSpecificationID = mapObj[key].toString()
//                    }
//                } else if (key == "DPBrandID") {
//                    if (!mapObj[key].toString().isNullOrEmpty() && mapObj[key].toString() != "null") {
//                        equipment.dpBrandID = mapObj[key].toString()
//                    }
//                }
//            }
//        }
//
//        /** 台账参数 */
//        if (equipManufactor.size > 0) {
//            ledgerParamMap["equipManufactor"] = equipManufactor
//        }
//        if (supplyPurchase.size > 0) {
//            ledgerParamMap["supplyPurchase"] = supplyPurchase
//        }
//        if (siteinstall.size > 0) {
//            ledgerParamMap["siteinstall"] = siteinstall
//        }
//        if (operationMainte.size > 0) {
//            ledgerParamMap["operationMainte"] = operationMainte
//        }
//        if (insuranceDoc.size > 0) {
//            ledgerParamMap["insuranceDoc"] = insuranceDoc
//        }
//        if (photoDoc.size > 0) {
//            ledgerParamMap["photoDoc"] = photoDoc
//        }
//
//        /** 通讯参数 */
//        if (agreement.size > 0) {
//            commParamMap["agreement"] = agreement
//        }
//        if (postalAddress.size > 0) {
//            commParamMap["postalAddress"] = postalAddress
//        }
//
//        /** 运行参数 */
//        if (instanState.size > 0) {
//            runParamMap["instanState"] = instanState
//        }
//        if (cumulaIndex.size > 0) {
//            runParamMap["cumulaIndex"] = cumulaIndex
//        }
//        if (exportWaterQuality.size > 0) {
//            runParamMap["exportWaterQuality"] = exportWaterQuality
//        }
//        if (cpuStates.size > 0) {
//            runParamMap["cpuStates"] = cpuStates
//        }
//        if (keyIndic.size > 0) {
//            runParamMap["keyIndic"] = keyIndic
//        }
//        if (switchingState.size > 0) {
//            runParamMap["switchingState"] = switchingState
//        }
//        if (voltage.size > 0) {
//            runParamMap["voltage"] = voltage
//        }
//        if (electricCurrent.size > 0) {
//            runParamMap["electricCurrent"] = electricCurrent
//        }
//        if (power.size > 0) {
//            runParamMap["power"] = power
//        }
//        if (totalHarmonic.size > 0) {
//            runParamMap["totalHarmonic"] = totalHarmonic
//        }
//        if (distortRate.size > 0) {
//            runParamMap["distortRate"] = distortRate
//        }
//        if (protect.size > 0) {
//            runParamMap["protect"] = protect
//        }
//        if (instanIndex.size > 0) {
//            runParamMap["instanIndex"] = instanIndex
//        }
//        if (waterSide.size > 0) {
//            runParamMap["waterSide"] = waterSide
//        }
//        if (airSide.size > 0) {
//            runParamMap["airSide"] = airSide
//        }
//        if (trayWater.size > 0) {
//            runParamMap["trayWater"] = trayWater
//        }
//        if (fans.size > 0) {
//            runParamMap["fan"] = fans
//        }
//        if (conduits.size > 0) {
//            runParamMap["conduits"] = conduits
//        }
//        if (cumuParam.size > 0) {
//            runParamMap["cumuParam"] = cumuParam
//        }
//
//
//        /** 温度传感器 */
//        if (tempGeneral.size > 0) {
//            tempSensor["tempGeneral"] = tempGeneral
//        }
//        if (thermTemperSensor.size > 0) {
//            tempSensor["thermTemperSensor"] = thermTemperSensor
//        }
//        if (resisTempeSensor.size > 0) {
//            tempSensor["resisTempeSensor"] = resisTempeSensor
//        }
//        if (thermTempeSensor.size > 0) {
//            tempSensor["thermTempeSensor"] = thermTempeSensor
//        }
//        if (iCTempSensor.size > 0) {
//            tempSensor["icTempSensor"] = iCTempSensor
//        }
//        if (glassTubeTherm.size > 0) {
//            tempSensor["glassTubeTherm"] = glassTubeTherm
//        }
//        if (pressureThermo.size > 0) {
//            tempSensor["pressureThermo"] = pressureThermo
//        }
//        if (infraredTempInstru.size > 0) {
//            tempSensor["infraredTempInstru"] = infraredTempInstru
//        }
//        if (runParam.size > 0) {
//            tempSensor["runParam"] = runParam
//        }
//        if (techParamqpm.size > 0) {
//            tempSensor["techParam"] = techParamqpm
//        }
//
//        /** 速度传感器 */
//        if (techParam.size > 0) {
//            speedSensor["techParam"] = techParam
//        }
//        if (runParamtwo.size > 0) {
//            speedSensor["runParam"] = runParamtwo
//        }
//
//        /** 声音传感器 */
//        if (generalVoice.size > 0) {
//            soundSensor["generalVoice"] = generalVoice
//        }
//        if (noiseSensor.size > 0) {
//            soundSensor["noiseSensor"] = noiseSensor
//        }
//        if (soundRecording.size > 0) {
//            soundSensor["soundRecording"] = soundRecording
//        }
//        if (runParamer.size > 0) {
//            soundSensor["runParam"] = runParamer
//        }
//
//        /** 湿度传感器 */
//        if (techParamq.size > 0) {
//            humiditySensor["techParam"] = techParamq
//        }
//        if (runParamtwoq.size > 0) {
//            humiditySensor["runParam"] = runParamtwoq
//        }
//
//        /** 压力传感器 */
//        if (techParamqp.size > 0) {
//            pressTransd["techParam"] = techParamqp
//        }
//        if (runParamtwoqp.size > 0) {
//            pressTransd["runParam"] = runParamtwoqp
//        }
//
//        /** 热量传感器 */
//        if (techParamqps.size > 0) {
//            heatSensor["techParam"] = techParamqps
//        }
//        if (runParamtwoqps.size > 0) {
//            heatSensor["runParam"] = runParamtwoqps
//        }
//
//        /** 浓度传感器 */
//        if (techParamqpseyqo.size > 0) {
//            concentSensor["techParam"] = techParamqpseyqo
//        }
//        if (runParamtwoqpseyqo.size > 0) {
//            concentSensor["runParam"] = runParamtwoqpseyqo
//        }
//
//        /** 图像传感器 */
//        if (techParamqpseyqoi.size > 0) {
//            imageSensor["techParam"] = techParamqpseyqoi
//        }
//        if (runParamtwoqpseyqoi.size > 0) {
//            imageSensor["runParam"] = runParamtwoqpseyqoi
//        }
//
//
//        /** 流量传感器 */
//        if (techParamqpse.size > 0) {
//            flowSensor["techParam"] = techParamqpse
//        }
//        if (runParamtwoqpse.size > 0) {
//            flowSensor["runParam"] = runParamtwoqpse
//        }
//
//        /** 电度传感器 */
//        if (techParamqpsey.size > 0) {
//            electricitySensor["techParam"] = techParamqpsey
//        }
//        if (runParamtwoqpsey.size > 0) {
//            electricitySensor["runParam"] = runParamtwoqpsey
//        }
//
//        /** 位移传感器 */
//        if (techParamqpseyq.size > 0) {
//            displSensor["techParam"] = techParamqpseyq
//        }
//        if (runParamtwoqpseyq.size > 0) {
//            displSensor["runParam"] = runParamtwoqpseyq
//        }
//
//        /** 技术参数 */
//        if (completeMachine.size > 0) {
//            techParamMap["completeMachine"] = completeMachine
//        }
//        if (waterPump.size > 0) {
//            techParamMap["waterPump"] = waterPump
//        }
//        if (filter.size > 0) {
//            techParamMap["filter"] = filter
//        }
//        if (fertiApplicator.size > 0) {
//            techParamMap["fertiApplicator"] = fertiApplicator
//        }
//        if (interflicator.size > 0) {
//            techParamMap["interflicator"] = interflicator
//        }
//        if (internalBladder.size > 0) {
//            techParamMap["internalBladder"] = internalBladder
//        }
//        if (internalBladder.size > 0) {
//            techParamMap["insulLayer"] = insulLayer
//        }
//        if (shell.size > 0) {
//            techParamMap["shell"] = shell
//        }
//        if (fineScreens.size > 0) {
//            techParamMap["fineScreens"] = fineScreens
//        }
//        if (regulatingPool.size > 0) {
//            techParamMap["regulatingPool"] = regulatingPool
//        }
//        if (sedimenTank.size > 0) {
//            techParamMap["sedimenTank"] = sedimenTank
//        }
//        if (hairFilter.size > 0) {
//            techParamMap["hairFilter"] = hairFilter
//        }
//        if (pressPump.size > 0) {
//            techParamMap["pressPump"] = pressPump
//        }
//        if (disinfeEquip.size > 0) {
//            techParamMap["disinfeEquip"] = disinfeEquip
//        }
//        if (membraneProcessingSystem.size > 0) {
//            techParamMap["membraneProcessingSystem"] = membraneProcessingSystem
//        }
//        if (canister.size > 0) {
//            techParamMap["canister"] = canister
//        }
//        if (reclaWater.size > 0) {
//            techParamMap["reclaWater"] = reclaWater
//        }
//        if (liftingPump.size > 0) {
//            techParamMap["liftingPump"] = liftingPump
//        }
//        if (frequeUnit.size > 0) {
//            techParamMap["frequeUnit"] = frequeUnit
//        }
//        if (pressureSteadyFlow.size > 0) {
//            techParamMap["pressureSteadyFlow"] = pressureSteadyFlow
//        }
//        if (auxiliaryEquip.size > 0) {
//            techParamMap["auxiliaryEquip"] = auxiliaryEquip
//        }
//        if (ultravGener.size > 0) {
//            techParamMap["ultravGener"] = ultravGener
//        }
//        if (ozoneGenerator.size > 0) {
//            techParamMap["ozoneGenerator"] = ozoneGenerator
//        }
//        if (collectorPlate.size > 0) {
//            techParamMap["collectorPlate"] = collectorPlate
//        }
//        if (coverPlate.size > 0) {
//            techParamMap["coverPlate"] = coverPlate
//        }
//        if (performance.size > 0) {
//            techParamMap["performance"] = performance
//        }
//        if (electricHeating.size > 0) {
//            techParamMap["electricHeating"] = electricHeating
//        }
//        if (heatExcha.size > 0) {
//            techParamMap["heatExcha"] = heatExcha
//        }
//        if (hotWaterBoiler.size > 0) {
//            techParamMap["hotWaterBoiler"] = hotWaterBoiler
//        }
//        if (steamBoiler.size > 0) {
//            techParamMap["steamBoiler"] = steamBoiler
//        }
//        if (flueGasWasteHeat.size > 0) {
//            techParamMap["flueGasWasteHeat"] = flueGasWasteHeat
//        }
//        if (steamConde.size > 0) {
//            techParamMap["steamConde"] = steamConde
//        }
//        if (refrigCondition.size > 0) {
//            techParamMap["refrigCondition"] = refrigCondition
//        }
//        if (heatingCondi.size > 0) {
//            techParamMap["heatingCondi"] = heatingCondi
//        }
//        if (softener.size > 0) {
//            techParamMap["softener"] = softener
//        }
//        if (reverseOsmosis.size > 0) {
//            techParamMap["reverseOsmosis"] = reverseOsmosis
//        }
//        if (waterStoragetank.size > 0) {
//            techParamMap["waterStoragetank"] = waterStoragetank
//        }
//        if (ultravSteri.size > 0) {
//            techParamMap["ultravSteri"] = ultravSteri
//        }
//        if (disinf.size > 0) {
//            techParamMap["disinf"] = disinf
//        }
//        if (heater.size > 0) {
//            techParamMap["heater"] = heater
//        }
//        if (tuner.size > 0) {
//            techParamMap["tuner"] = tuner
//        }
//        if (receiver.size > 0) {
//            techParamMap["receiver"] = receiver
//        }
//        if (mixer.size > 0) {
//            techParamMap["mixer"] = mixer
//        }
//        if (monitor.size > 0) {
//            techParamMap["monitor"] = monitor
//        }
//        if (powerAmpli.size > 0) {
//            techParamMap["powerAmpli"] = powerAmpli
//        }
//        if (modulator.size > 0) {
//            techParamMap["modulator"] = modulator
//        }
//        if (branchDis.size > 0) {
//            techParamMap["branchDis"] = branchDis
//        }
//        if (opticalTerminal.size > 0) {
//            techParamMap["opticalTerminal"] = opticalTerminal
//        }
//        if (player.size > 0) {
//            techParamMap["player"] = player
//        }
//        if (display.size > 0) {
//            techParamMap["display"] = display
//        }
//        if (iCCardReader.size > 0) {
//            techParamMap["icCardReader"] = iCCardReader
//        }
//        if (passwordKeyb.size > 0) {
//            techParamMap["passwordKeyb"] = passwordKeyb
//        }
//        if (iDCardReader.size > 0) {
//            techParamMap["idCardReader"] = iDCardReader
//        }
//        if (printer.size > 0) {
//            techParamMap["printer"] = printer
//        }
//        if (fingerIdent.size > 0) {
//            techParamMap["fingerIdent"] = fingerIdent
//        }
//        if (camera.size > 0) {
//            techParamMap["camera"] = camera
//        }
//        if (otherEquip.size > 0) {
//            techParamMap["otherEquip"] = otherEquip
//        }
//        if (generalElecIndex.size > 0) {
//            techParamMap["generalElecIndex"] = generalElecIndex
//        }
//        if (spatialRadiIndex.size > 0) {
//            techParamMap["spatialRadiIndex"] = spatialRadiIndex
//        }
//        if (wirelessModule.size > 0) {
//            techParamMap["wirelessModule"] = wirelessModule
//        }
//        if (launchIndex.size > 0) {
//            techParamMap["launchIndex"] = launchIndex
//        }
//        if (receiIndex.size > 0) {
//            techParamMap["receiIndex"] = receiIndex
//        }
//        if (videoType.size > 0) {
//            techParamMap["videoType"] = videoType
//        }
//        if (infraredDetector.size > 0) {
//            techParamMap["infraredDetector"] = infraredDetector
//        }
//        if (glassCrushDetec.size > 0) {
//            techParamMap["glassCrushDetec"] = glassCrushDetec
//        }
//        if (motor.size > 0) {
//            techParamMap["motor"] = motor
//        }
//        if (brake.size > 0) {
//            techParamMap["brake"] = brake
//        }
//        if (retarder.size > 0) {
//            techParamMap["retarder"] = retarder
//        }
//        if (coupling.size > 0) {
//            techParamMap["coupling"] = coupling
//        }
//        if (generatorSet.size > 0) {
//            techParamMap["generatorSet"] = generatorSet
//        }
//        if (dieselEngine.size > 0) {
//            techParamMap["dieselEngine"] = dieselEngine
//        }
//        if (population.size > 0) {
//            techParamMap["population"] = population
//        }
//        if (input.size > 0) {
//            techParamMap["input"] = input
//        }
//        if (input.size > 0) {
//            techParamMap["output"] = output
//        }
//        if (battery.size > 0) {
//            techParamMap["battery"] = battery
//        }
//        if (loadSwitch.size > 0) {
//            techParamMap["loadSwitch"] = loadSwitch
//        }
//        if (fuse.size > 0) {
//            techParamMap["fuse"] = fuse
//        }
//        if (earthingSwitch.size > 0) {
//            techParamMap["earthingSwitch"] = earthingSwitch
//        }
//        if (lowBreaker.size > 0) {
//            techParamMap["lowBreaker"] = lowBreaker
//        }
//        if (lowBreaker.size > 0) {
//            techParamMap["voltageTrans"] = voltageTrans
//        }
//        if (currentTrans.size > 0) {
//            techParamMap["currentTrans"] = currentTrans
//        }
//        if (contactor.size > 0) {
//            techParamMap["contactor"] = contactor
//        }
//        if (leakageProtector.size > 0) {
//            techParamMap["leakageProtector"] = leakageProtector
//        }
//        if (relay.size > 0) {
//            techParamMap["relay"] = relay
//        }
//        if (connectionTerminal.size > 0) {
//            techParamMap["connectionTerminal"] = connectionTerminal
//        }
//        if (switchProte.size > 0) {
//            techParamMap["switchProte"] = switchProte
//        }
//        if (circuitBreaker.size > 0) {
//            techParamMap["circuitBreaker"] = circuitBreaker
//        }
//        if (thermalInsulMaterial.size > 0) {
//            techParamMap["thermalInsulMaterial"] = thermalInsulMaterial
//        }
//        if (plasticPipe.size > 0) {
//            techParamMap["plasticPipe"] = plasticPipe
//        }
//        if (rectDuct.size > 0) {
//            techParamMap["rectDuct"] = rectDuct
//        }
//        if (circularDuct.size > 0) {
//            techParamMap["circularDuct"] = circularDuct
//        }
//        if (flatCircularDuct.size > 0) {
//            techParamMap["flatCircularDuct"] = flatCircularDuct
//        }
//        if (currency.size > 0) {
//            techParamMap["currency"] = currency
//        }
//        if (safetyValve.size > 0) {
//            techParamMap["safetyValve"] = safetyValve
//        }
//        if (pressRreliefValve.size > 0) {
//            techParamMap["pressRreliefValve"] = pressRreliefValve
//        }
//        if (coil.size > 0) {
//            techParamMap["coil"] = coil
//        }
//        if (contact.size > 0) {
//            techParamMap["contact"] = contact
//        }
//        if (onOffValve.size > 0) {
//            techParamMap["onOffValve"] = onOffValve
//        }
//        if (checkValve.size > 0) {
//            techParamMap["checkValve"] = checkValve
//        }
//        if (regulValve.size > 0) {
//            techParamMap["regulValve"] = regulValve
//        }
//        if (foamExtinguisher.size > 0) {
//            techParamMap["foamExtinguisher"] = foamExtinguisher
//        }
//        if (dryPowderExti.size > 0) {
//            techParamMap["dryPowderExti"] = dryPowderExti
//        }
//        if (carbonExting.size > 0) {
//            techParamMap["carbonExting"] = carbonExting
//        }
//        if (halogAgentExting.size > 0) {
//            techParamMap["halogAgentExting"] = halogAgentExting
//        }
//        if (cleanWaterExting.size > 0) {
//            techParamMap["cleanWaterExting"] = cleanWaterExting
//        }
//        if (host.size > 0) {
//            techParamMap["host"] = host
//        }
//        if (preamplifier.size > 0) {
//            techParamMap["preamplifier"] = preamplifier
//        }
//        if (matrix.size > 0) {
//            techParamMap["matrix"] = matrix
//        }
//        if (cdRecording.size > 0) {
//            techParamMap["cdRecording"] = cdRecording
//        }
//        if (keel.size > 0) {
//            techParamMap["keel"] = keel
//        }
//        if (panel.size > 0) {
//            techParamMap["panel"] = panel
//        }
//        if (assembly.size > 0) {
//            techParamMap["assembly"] = assembly
//        }
//        if (compressor.size > 0) {
//            techParamMap["compressor"] = compressor
//        }
//        if (evaporator.size > 0) {
//            techParamMap["evaporator"] = evaporator
//        }
//        if (throtElement.size > 0) {
//            techParamMap["throtElement"] = throtElement
//        }
//        if (condenser.size > 0) {
//            techParamMap["condenser"] = condenser
//        }
//        if (generator.size > 0) {
//            techParamMap["generator"] = generator
//        }
//        if (absorber.size > 0) {
//            techParamMap["absorber"] = absorber
//        }
//        if (fan.size > 0) {
//            techParamMap["fan"] = fan
//        }
//        if (filterSegment.size > 0) {
//            techParamMap["filterSegment"] = filterSegment
//        }
//        if (heatRecoverySection.size > 0) {
//            techParamMap["heatRecoverySection"] = heatRecoverySection
//        }
//        if (surfaceCoolSection.size > 0) {
//            techParamMap["surfaceCoolSection"] = surfaceCoolSection
//        }
//        if (humidSection.size > 0) {
//            techParamMap["humidSection"] = humidSection
//        }
//        if (reheaSection.size > 0) {
//            techParamMap["reheaSection"] = reheaSection
//        }
//        if (airSupply.size > 0) {
//            techParamMap["airSupply"] = airSupply
//        }
//        if (waterHeatingEquip.size > 0) {
//            techParamMap["waterHeatingEquip"] = waterHeatingEquip
//        }
//        if (carCryGroHeatEquip.size > 0) {
//            techParamMap["carCryGroHeatEquip"] = carCryGroHeatEquip
//        }
//        if (thermCableEquip.size > 0) {
//            techParamMap["thermCableEquip"] = thermCableEquip
//        }
//        if (conduit.size > 0) {
//            techParamMap["conduits"] = conduit
//        }
//        if (freshAir.size > 0) {
//            techParamMap["freshAir"] = freshAir
//        }
//        if (mixingSection.size > 0) {
//            techParamMap["mixingSection"] = mixingSection
//        }
//        if (other.size > 0) {
//            techParamMap["other"] = other
//        }
//        /** 人流量传感器 */
//        if (runParamMan.size > 0) {
//            manFlowSensor["runParam"] = runParamMan
//        }
//        if (techParamqpMam.size > 0) {
//            manFlowSensor["techParam"] = techParamqpMam
//        }
//        if (humiditySensor.size > 0) {
//            equipment.humiditySensor = humiditySensor
//        }
//
//        if (ledgerParamMap.size > 0) {
//            equipment.ledgerParam = ledgerParamMap
//        }
//        if (commParamMap.size > 0) {
//            equipment.commParam = commParamMap
//        }
//        if (techParamMap.size > 0) {
//            equipment.techParam = techParamMap
//        }
//        if (runParamMap.size > 0) {
//            equipment.runParam = runParamMap
//        }
//        if (settingParamMap.size > 0) {
//            equipment.settingParam = settingParamMap
//        }
//        if (alramMap.size > 0) {
//            equipment.alram = alramMap
//        }
//        if (customParamMap.size > 0) {
//            equipment.customParam = customParamMap
//        }
//        if (tempSensor.size > 0) {
//            equipment.tempSensor = tempSensor
//        }
//        if (techParamGeneral.size > 0) {
//            equipment.techParamGeneral = techParamGeneral
//        }
//        if (runParamGeneral.size > 0) {
//            equipment.runParamGeneral = runParamGeneral
//        }
//        if (speedSensor.size > 0) {
//            equipment.speedSensor = speedSensor
//        }
////        if (humidSection.size>0){
////            equip.humiditySensor = humidSection
////        }
//        if (pressTransd.size > 0) {
//            equipment.pressTransd = pressTransd
//        }
//        if (heatSensor.size > 0) {
//            equipment.heatSensor = heatSensor
//        }
//        if (flowSensor.size > 0) {
//            equipment.flowSensor = flowSensor
//        }
//        if (electricitySensor.size > 0) {
//            equipment.electricitySensor = electricitySensor
//        }
//        if (displSensor.size > 0) {
//            equipment.displSensor = displSensor
//        }
//        if (concentSensor.size > 0) {
//            equipment.concentSensor = concentSensor
//        }
//        if (imageSensor.size > 0) {
//            equipment.imageSensor = imageSensor
//        }
//        if (imageSensor.size > 0) {
//            equipment.imageSensor = imageSensor
//        }
//        if (feedbackParam.size > 0) {
//            equipment.feedbackParam = feedbackParam
//        }
//        if (manFlowSensor.size > 0) {
//            equipment.manFlowSensor = manFlowSensor
//        }
//
//        return equipment
//    }


    /**
     * 设备转换
     */
    fun equipSyns(projectId: String,groupCode: String, mapObj: HashMap<String, Any?>): Equipment {
        val equipment = Equipment()
        /** 查建楼层型字典 */
        var dictDefFuncIdList = dictDefFuncIdService.select(SFilter.eq("groupCode", groupCode),SFilter.eq("projectId", projectId), SFilter.eq("classCode", mapObj["classCode"].toString())).exec()
        if (dictDefFuncIdList.isNullOrEmpty()) {
            dictDefFuncIdList = dictDefFuncIdService.select(SFilter.eq("type", "commo"),
                SFilter.eq("classCode", mapObj["classCode"].toString())).exec()
        }

        val mapEx = HashMap<String, Any?>()
        val mapCode = HashMap<String, Any?>()
        /** 遍历项目类型字典 */
        for (explainProject in dictDefFuncIdList) {
            /** 输入类型 */
            mapEx[explainProject.code!!] = explainProject.dataType
            mapCode[explainProject.code!!] = explainProject.category
        }
        logger.debug("打印= ${mapObj.toJson()}")

        equipment.projectId = projectId
        equipment.classCode = mapObj["classCode"].toString()
        equipment.id =  mapObj["id"]!!.toString()
        val containsKey14 = mapObj.containsKey("name")
        if (containsKey14){
            equipment.name =  mapObj["name"]!!.toString()
        }

        try {
            val containsKey2 = mapObj.containsKey("localId")
            if (containsKey2) {
                equipment.localId =  mapObj["localId"]!!.toString()
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
        val containsKey3 = mapObj.containsKey("localName")
        if (containsKey3) {
            equipment.localName =  mapObj["localName"]!!.toString()
       }
        val containsKey4 = mapObj.containsKey("defaultQRCode")
        if (containsKey4) {
            equipment.defaultQRCode =  mapObj["defaultQRCode"]!!.toString()
        }
        val containsKey5 = mapObj.containsKey("rfId")
        if (containsKey5) {
            equipment.rfId =  mapObj["rfId"]!!.toString()
        }
        val containsKey6 = mapObj.containsKey("cadId")
        if (containsKey6) {
            equipment.cadId =  mapObj["cadId"]!!.toString()
        }
        val containsKey7 = mapObj.containsKey("cADID")
        if (containsKey7) {
            equipment.cadId =  mapObj["cADID"]!!.toString()
        }
        val containsKey8 = mapObj.containsKey("bimFamilyName")
        if (containsKey8) {
            equipment.bimFamilyName =  mapObj["bimFamilyName"]!!.toString()
        }
        val containsKey9 = mapObj.containsKey("bimFamilySymbol")
        if (containsKey9) {
            equipment.bimFamilySymbol =  mapObj["bimFamilySymbol"]!!.toString()
        }
        val containsKey10 = mapObj.containsKey("bimTypeId")
        if (containsKey10) {
            equipment.bimTypeId =  mapObj["bimTypeId"]!!.toString()
        }
        val containsKey11 = mapObj.containsKey("bimId")
        if (containsKey11) {
            equipment.bimId =  mapObj["bimId"]!!.toString()
        }
        val containsKey12 = mapObj.containsKey("bimLocation")
        if (containsKey12) {
            equipment.bimLocation =  mapObj["bimLocation"]!!.toString()
        }
        val containsKey13 = mapObj.containsKey("equipSerial")
        if (containsKey13) {
            equipment.equipSerial =  mapObj["equipSerial"]!!.toString().toDoubleOrNull()
        }

        try {
            for (key in mapObj.keys) {
                val containsKey = mapEx.containsKey(key)
                if (containsKey){
                    if (key != "id"&& key!="name"&&key!="localId"&&key!="localName"&&key!="defaultQRCode"
                        &&key!="qRCodePic"&&key!="rfId"&&key!="cadId"&&key!="bimFamilyName"&&key!="bimFamilySymbol"
                        &&key!="bimTypeId"&&key!="bimId"&&key!="bimLocation"&&key!="equipSerial"){
                        val containsKey1 = mapCode.containsKey(key)
                        if (containsKey1){
                            val any = mapCode[key].toString()
                            if (any == "STATIC"){
                                when(mapEx[key].toString()) {
                                    "INTEGER" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!.toInt()
                                    }
                                    "DOUBLE" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!.toString().toDoubleOrNull()
                                    }
                                    "BOOLEAN" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]
                                    }
                                    "STRING" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!.toString()
                                    }
                                    "DATETIME" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]
                                    }
                                    "ATTACHMENT" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!
                                    }
                                    "OBJECT" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]
                                    }
                                    "ENUM" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!
                                    }
                                    "MENUM" -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!
                                    }
                                    else -> {
                                        if (equipment.infos.isNullOrEmpty()){
                                            equipment.infos = HashMap<String,Any?>()
                                        }
                                        equipment.infos!![key] = mapObj[key]!!.toString()
                                    }
                                }
                            }else{
                                if (equipment.infos.isNullOrEmpty()){
                                    equipment.infos = HashMap<String,Any?>()
                                }
                                equipment.infos!![key] = mapObj[key]!!.toString()
                            }
                        }

                    } else {
                        try {
                            when(key) {
                                "id" -> equipment.id =  mapObj[key]!!.toString()
                                "name" -> equipment.name =  mapObj[key]!!.toString()
                                "localId" -> equipment.localId =  mapObj[key]!!.toString()
                                "localName" -> equipment.localName =  mapObj[key]!!.toString()
                                "defaultQRCode" -> equipment.defaultQRCode =  mapObj[key]!!.toString()
//                                "qRCodePic" ->{
//                                    equipment.qRCodePic =  mapObj[key]
//                                }
                                "rfId" -> equipment.rfId =  mapObj[key]!!.toString()
                                "cadId" -> equipment.cadId =  mapObj[key]!!.toString()
                                "bimFamilyName" -> equipment.bimFamilyName =  mapObj[key]!!.toString()
                                "bimFamilySymbol" -> equipment.bimFamilySymbol =  mapObj[key]!!.toString()
                                "bimTypeId" -> equipment.bimTypeId =  mapObj[key]!!.toString()
                                "bimId" -> equipment.bimId =  mapObj[key]!!.toString()
                                "bimLocation" -> equipment.bimLocation =  mapObj[key]!!.toString()
                                "equipSerial" -> equipment.equipSerial =  mapObj[key]!!.toString().toDoubleOrNull()
                            }
                        } catch (e: Exception) {
                            e.printStackTrace()
                        }
                    }

                } else {
    //                if (equipment.infos.isNullOrEmpty()){
    //                    equipment.infos = HashMap<String,Any?>()
    //                }
    //                equipment.infos!![key] =  mapObj[key]!!.toString()
                }
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return equipment
    }

    /**
     * 设备工具
     *
     * @param projectId     项目 id
     * @param equipment     设备对象
     * @return 返回结果
     */
    fun equipTools(projectId: String,equipment: Equipment): ArrayList<HashMap<String,Any?>> {
        var list = ArrayList<HashMap<String,Any?>>()
        val hashMap = HashMap<String, Any?>()
        hashMap["id"] = equipment.id
        hashMap["name"] = equipment.name
        hashMap["projectId"] = projectId
        hashMap["objType"] = "equipment"
        hashMap["classCode"] = equipment.classCode
        if (!equipment.wdCode.isNullOrEmpty()){
            hashMap["wdCode"] = equipment.wdCode
        }
        if (!equipment.localName.isNullOrEmpty()){
            hashMap["localName"] = equipment.localName
        }
        if (!equipment.localId.isNullOrEmpty()){
            hashMap["localId"] = equipment.localId
        }
        if (!equipment.defaultQRCode.isNullOrEmpty()){
            hashMap["defaultQRCode"] = equipment.defaultQRCode
        }
        if (!equipment.qRCodePic.isNullOrEmpty()){
            hashMap["qRCodePic"] = equipment.qRCodePic
        }
        if (!equipment.	rfId.isNullOrEmpty()){
            hashMap["rfId"] = equipment.rfId
        }
        if (!equipment.cadId.isNullOrEmpty()){
            hashMap["cadId"] = equipment.cadId
            hashMap["cADID"] = equipment.cadId
        }
        if (!equipment.bimId.isNullOrEmpty()){
            hashMap["bimId"] = equipment.bimId
        }
        if (!equipment.bimLocation.isNullOrEmpty()){
            hashMap["bimLocation"] = equipment.bimLocation
        }
        if (!equipment.bimFamilyName.isNullOrEmpty()){
            hashMap["bimFamilyName"] = equipment.bimFamilyName
        }
        if (!equipment.bimFamilySymbol.isNullOrEmpty()){
            hashMap["bimFamilySymbol"] = equipment.bimFamilySymbol
        }
        if (!equipment.bimTypeId.isNullOrEmpty()){
            hashMap["bimTypeId"] = equipment.bimTypeId
        }
        if (equipment.equipSerial!=null&&equipment.equipSerial!=0.0){
            hashMap["equipSerial"] = equipment.equipSerial
        }
        if (!equipment.infos.isNullOrEmpty()){
            for (key in equipment.infos!!.keys){
                hashMap[key] = equipment.infos!![key]
            }
        }

        list.add(hashMap)
        return list
    }



}