/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server

import com.persagy.service.SPageContext

/**
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/11/4 21:36
 */
object Opt {

    /** 项目 id */
    val projectId: String?
        get() = SPageContext.getHeader("projectId")
    /** 集团编码 */
    val groupCode: String?
        get() = SPageContext.getHeader("groupCode")

    /** 数据来源 */
    val coming: String?
        get() = SPageContext.getHeader("coming")
    /** 账号信息 */
    val account: String?
        get() = SPageContext.getHeader("account")


    /**  使用字典信息点全局定义 ****************************************************************************/
    /** 楼层平面图 */
    const val FLOORMAP = "floorMap"
    /**楼层标高 */
    const val FLOORELEVATION = "floorElevation"
    /** 高度 */
    const val HEIGHt = "height"
    /** 安装位置 */
    const val INSTALLLOCATION = "installLocation"
    /** 生产厂家名称 */
    val MANUFACTURER = "manufacturer"
    /** 设备型号 */
    val SPECIFICATION = "Specification"
    /** 供应商单位名称 */
    val SUPPLIER = "Supplier"
    /** 设备照片 */
    val PIC = "pic"
    /** 竖井类型 */
    val SHAFTFUNCTYPE = "shaftFuncType"
    /** 设备文档 */
    val ARCHIVE = "Archive"
    /** 安装质检报告 */
    val CHECKREPORT = "CheckReport"
    /** 设备图纸 */
    val DRAWING = "Drawing"
    /** 安装图纸 */
    val INSTALLDRAWING = "installDrawing"
    /** 安装照片 */
    val INSTALLPIC = "installPic"
    /** 保险文件 */
    val INSURANCEFILE = "insuranceFile"
    /** 设备铭牌照片 */
    val NAMEPLATE = "nameplate"
    /** 操作说明书 */
    val OPERATIONMANUAL = "operationManual"
    /** 产品合格证 */
    val PRODUCTCERTIFICATION = "productCertification"
    /** 维修保养手册 */
    val MAINTAINMANUAL = "maintainManual"
    /** 安装说明书 */
    val INSTALLINSTRUCTION = "installInstruction"
    /** 验收报告 */
    val ACCEPTANCEREPORT = "acceptanceReport"
    /** 进场验收单 */
    val APPROACHINGACCEPTANCE = "approachingAcceptance"
    /** 供应合同 */
    val SUPPLIERCONTRACT = "supplierContract"
    /** 检测报告 */
    val TESTREPORT = "TestReport"
    /** 原厂证明 */
    val ORIGINALCERTIFICATE = "OriginalCertificate"
}