/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.dao

import org.apache.ibatis.jdbc.SQL


class EquipZoneDao {

    fun selectEquipUnderSpace(projectId: String,zoneType : String?, zoneId : String?) : String{
        return object : SQL() {
            init {
                SELECT("equip_id")
                FROM("r_eq_in_sp_base")
                // 多个where条件之间是默认and连接
                WHERE("project_id = #{projectId} ")
                if(zoneType != null)
                    WHERE("object_type = #{zoneType}")
                if(zoneId != null)
                    WHERE("space_id = #{zoneId}")
            }
        }.toString()
    }



    fun similarityDegree(name: String,listStr:List<String>, total: Int, similar:Float): String{
        return object : SQL() {
            init {
                SELECT("public.rel_str_similar(#{name}," +
                        " ARRAY["+arrToString(listStr)+
                        "]" +
                        ", #{total}," +
                        " #{similar})")

            }
        }.toString()
    }

    fun arrToString(listStr:List<String>): String{
        var str = ""
        for (ind in listStr.indices){

//            if (listStr.size-1==ind){
//                str+="'"+listStr[ind]+"'"
//            }else{
//                str+="'"+listStr[ind]+"'"+","
//            }
            if (listStr.size-1==ind){
                str+="#{listStr[${ind}]}"
            }else{
                str+="#{listStr[${ind}]}"+","
            }
        }
        return str
    }


//    object HelloWorld {
//        @JvmStatic
//        fun main(args: Array<String>) {
////            val list = ArrayList<String>()
////            list.add("北京")
////            list.add("田径")
////            val equipZoneDao = EquipZoneDao()
////            val arrToString = equipZoneDao.similarityDegree("北京",list,list.size,0.0f)
////
//            val str = "测试's"
//            val replace = str.replace("'", "\\\'")
//
//            println(replace)
//        }
//    }

}