/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.models

import com.persagy.server.datacenter.models.entities.base.BaseInfo
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Table

/**
 * 部件关联的资产
 *
 * @author 张维新
 */
@Schema(description = "部件关联的资产")
@Table(name = "v_component_property")
class ComponentProperty : BaseInfo(){

    /** 部件id */
    @Schema(description = "部件id",required = true)
    @Column(name = "id")
    var id: String? = null

    /** 部件名称 */
    @Schema(description = "部件名称",required = true)
    @Column(name = "name")
    var name: String? = null

    /** 部件本地编码 */
    @Schema(description = "部件本地编码")
    @Column(name = "local_id")
    var localId: String? = null

    /** 部件本地名称 */
    @Schema(description = "部件本地名称")
    @Column(name = "local_name")
    var localName: String? = null

    /** 部件二维码照片 */
    @Schema(description = "部件二维码照片")
    @Column(name = "qr_code")
    var qrCode: String? = null

    /** 设计图纸中编码 */
    @Schema(description = "设计图纸中编码")
    @Column(name = "cad_id")
    var cadId: String? = null

    /** BIM模型中编码 */
    @Schema(description = "BIM模型中编码")
    @Column(name = "bim_id")
    var bimId: String? = null

    /** BIM模型中坐标 */
    @Schema(description = "BIM模型中坐标")
    @Column(name = "bim_location")
    var bimLocation: String? = null

    /** 项目id */
    @Schema(description = "项目id",required = true)
    @Column(name = "project_id")
    var projectId: String? = null

    /** 部件类型code */
    @Schema(description = "部件类型code")
    @Column(name = "class_code")
    var category: String? = null

    /** 部件所在建筑id */
    @Schema(description = "部件所在建筑id")
    @Column(name = "building_id")
    var buildingId: String? = null

    /** 部件所在楼层id */
    @Schema(description = "部件所在楼层id")
    @Column(name = "floor_id")
    var floorId: String? = null

    /** 品牌型号id */
    @Schema(description = "品牌型号id")
    @Column(name = "dp_manufacturer_id")
    var dpManufacturerID: String? = null

    /** 供应商信息id */
    @Schema(description = "供应商信息id")
    @Column(name = "dp_supplier_id")
    var dpSupplierID: String? = null

    /** 维修商信息id */
    @Schema(description = "维修商信息id")
    @Column(name = "dp_maintainer_id")
    var dpMaintainerID: String? = null

    /** 保险公司信息id */
    @Schema(description = "保险公司信息id")
    @Column(name = "dp_insurer_id")
    var dpInsurerID: String? = null

    /** 设备型号id */
    @Schema(description = "设备型号id")
    @Column(name = "dp_specification_id")
    var dpSpecificationID: String? = null

    /** 品牌id */
    @Schema(description = "品牌id")
    @Column(name = "dp_brand_id")
    var dpBrandID: String? = null

    /** 信息点 */
    @Schema(description = "信息点")
    @Column(name = "infos")
    var infos: HashMap<String,Any?>? = null

    /** 关联设备id */
    @Schema(description = "关联设备id")
    @Column(name = "parent_id")
    var parentId: String? = null

    /** 资产名称 */
    @Schema(description = "资产名称")
    @Column(name = "property_name")
    var propertyName: String? = null

    /** 资产本地名称 */
    @Schema(description = "资产本地名称")
    @Column(name = "property_local_name")
    var propertyLocalName: String? = null

    /** 资产id */
    @Schema(description = "资产id")
    @Column(name = "property_id")
    var propertyId: String? = null

}