/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.models.mappers

import org.apache.ibatis.jdbc.SQL

/**
 * 统计
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/12/13 16:45
 */
class StatisticalQuantity {


    /**
     * 统计设备类型函数
     *
     * @param projectId     项目 id
     * @param buildingId    建筑 id
     * @param floorId       楼层 id
     * @param types         类型列表
     * @return sql 字符串
     */
    fun equipTypeCount(projectId: String,buildingId: String,floorId: String,types: ArrayList<String>): String {
        val type = concateStr(types)
        val sql = object: SQL() {
            init {
                //
                SELECT("e.class_code AS code , (SELECT name FROM dict.def_class WHERE project_id = 'Pj1101050029' AND code = e.class_code ) ,  count('class_code')")
                FROM("equipment e")
                WHERE("e.project_id = '${projectId}' AND e.building_id = '${buildingId}' AND e.floor_id = '${floorId}' AND e.class_code in (${type})")
                GROUP_BY(" e.class_code")
            }
        }.toString()
        return sql
    }


    /**
     * in 列表的字符串拼接
     *
     * @param arr     集合列表
     */
    fun concateStr(arr : Collection<String>) : String{
        var stringBuilder = StringBuilder()
        arr.forEach {
            stringBuilder.append("\'").append(it).append("\',")
        }
        if(stringBuilder.endsWith(',')){
            stringBuilder.deleteCharAt(stringBuilder.length - 1) //.removeSuffix(",")
        }
        return stringBuilder.toString()
    }
}