/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.models.requests

import com.persagy.server.datacenter.models.entities.assistant.TaskPic
import io.swagger.v3.oas.annotations.media.Schema
import java.io.Serializable


/**
 * 增量附件
 *
 * @author wx <zhangweixin@sagacloud.cn>
 */
class EquipUpDateEnclosure :Serializable {

    /** 设备id */
    @Schema(description = "设备id",required = true)
    var equipId: String? = null

    /** 保险文件 */
    @Schema(description = "保险文件",required = true)
    var insuranceFile: ArrayList<TaskPic>? = null

    /** 设备铭牌照片 */
    @Schema(description = "设备铭牌照片",required = true)
    var nameplate: ArrayList<TaskPic>? = null

    /** 设备照片 */
    @Schema(description = "设备照片",required = true)
    var pic: ArrayList<TaskPic>? = null

    /** 设备图纸 */
    @Schema(description = "设备图纸",required = true)
    var drawing: ArrayList<TaskPic>? = null

    /** 设备文档 */
    @Schema(description = "设备文档",required = true)
    var archive: ArrayList<TaskPic>? = null

    /** 安装照片 */
    @Schema(description = "安装照片",required = true)
    var installPic: ArrayList<TaskPic>? = null

    /** 安装图纸 */
    @Schema(description = "安装图纸",required = true)
    var installDrawing: ArrayList<TaskPic>? = null

    /** 安装质检报告 */
    @Schema(description = "安装质检报告",required = true)
    var checkReport: ArrayList<TaskPic>? = null

    /** 操作说明书 */
    @Schema(description = "操作说明书",required = true)
    var operationManual: ArrayList<TaskPic>? = null

    /** 产品合格证 */
    @Schema(description = "产品合格证",required = true)
    var productCertification: ArrayList<TaskPic>? = null

    /** 维修保养手册 */
    @Schema(description = "维修保养手册",required = true)
    var maintainManual: ArrayList<TaskPic>? = null

    /** 安装说明书 */
    @Schema(description = "安装说明书",required = true)
    var installInstruction: ArrayList<TaskPic>? = null

    /** 验收报告 */
    @Schema(description = "验收报告",required = true)
    var acceptanceReport: ArrayList<TaskPic>? = null

    /** 进场验收单 */
    @Schema(description = "进场验收单",required = true)
    var approachingAcceptance: ArrayList<TaskPic>? = null

    /** 供应合同 */
    @Schema(description = "供应合同",required = true)
    var supplierContract: ArrayList<TaskPic>? = null

    /** 检测报告 */
    @Schema(description = "检测报告",required = true)
    var testReport: ArrayList<TaskPic>? = null

    /** 原厂证明 */
    @Schema(description = "原厂证明",required = true)
    var originalCertificate: ArrayList<TaskPic>? = null
}