/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.utils

import com.persagy.database.SFilter
import com.persagy.database.SPageQueryInfo
import com.persagy.database.functions.SLength
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.assistant.ViewEquipSystem
import com.persagy.server.datacenter.wanda.obj.GeneralSystem
import com.persagy.server.datacenter.models.response.EquipAssetComponentsReqponse
import com.persagy.server.service.objects.EquipmentService
import com.persagy.service.SBaseService

/**
 * 数据校验
 *
 * @author 张维新
 */
object DataVerification {

    /**
     * 查询 设备关联的资产 部件数量帮助接口
     */
    fun getEquipAssetComponentsTools(equipAssetComponentsList: SPageQueryInfo<EquipAssetComponentsReqponse>): ArrayList<EquipAssetComponentsReqponse> {
        /** 设备关联系统服务 */
        val viewEquipSystemservice = SBaseService(SMybatisDao(ViewEquipSystem::class.java))
        val generalSystemService = SBaseService(SMybatisDao(GeneralSystem::class.java))
        val list = ArrayList<EquipAssetComponentsReqponse>()
        if (equipAssetComponentsList.total!! > 0) {
            val contentList = equipAssetComponentsList.content
            for (content in contentList!!) {

                val exec = EquipmentService.select(SFilter.lte(SLength("category"), 6), SFilter.eq("parentId", content.id!!)).exec()

                content.count = exec.size
//                var equipAssetComponentsReqponse = EquipAssetComponentsReqponse()
//                equipAssetComponentsReqponse.id = content.id
//                equipAssetComponentsReqponse.linkId = content.linkId
//                equipAssetComponentsReqponse.linkEquipName = content.linkName
//                equipAssetComponentsReqponse.linkFamily = content.linkFamily
//                equipAssetComponentsReqponse.linkEquipLocalName = content.linkLocalName
//                equipAssetComponentsReqponse.count = exec.size
//                equipAssetComponentsReqponse.name = content.name
//                equipAssetComponentsReqponse.customParam = content.customParam
//                equipAssetComponentsReqponse.alram = content.alram
//                equipAssetComponentsReqponse.settingParam = content.settingParam
//                equipAssetComponentsReqponse.runParam = content.runParam
//                equipAssetComponentsReqponse.techParam = content.techParam
//                equipAssetComponentsReqponse.category = content.category
//                equipAssetComponentsReqponse.buildingId = content.buildingId
//                equipAssetComponentsReqponse.projectId = content.projectId
//                equipAssetComponentsReqponse.floorId = content.floorId
//                equipAssetComponentsReqponse.bimId = content.bimId
//                equipAssetComponentsReqponse.bimLocation = content.bimLocation
//                equipAssetComponentsReqponse.cadId = content.cadId
//                equipAssetComponentsReqponse.commParam = content.commParam
//                equipAssetComponentsReqponse.ledgerParam = content.ledgerParam
//                equipAssetComponentsReqponse.localId = content.localId
//                equipAssetComponentsReqponse.localName = content.localName
//                equipAssetComponentsReqponse.qrCode = content.qrCode
//                equipAssetComponentsReqponse.dpInsurerID = content.dpInsurerID
//                equipAssetComponentsReqponse.dpMaintainerID = content.dpMaintainerID
//                equipAssetComponentsReqponse.dpManufacturerID = content.dpManufacturerID
//                equipAssetComponentsReqponse.dpSupplierID = content.dpSupplierID
//                equipAssetComponentsReqponse.techParamGeneral = content.techParamGeneral
//                equipAssetComponentsReqponse.runParamGeneral = content.runParamGeneral

                val generalSystemList = ArrayList<GeneralSystem>()
                val systemList = viewEquipSystemservice.select(SFilter.eq("equipId", content.id!!)).exec()
                try {
                    if (!systemList.isEmpty()) {

                        for (system in systemList) {
                            if (!system.id.isNullOrEmpty()){
                                val systemEntity = generalSystemService.select(SFilter.eq("id", system.id!!)).entity()
                                if (systemEntity!=null){
                                    val generalSystem = GeneralSystem()
                                    generalSystem.id = system.id
                                    generalSystem.name = systemEntity.name
                                    generalSystem.localName = systemEntity.localName
                                    generalSystem.classCode = system.category
                                    generalSystemList.add(generalSystem)
                                }
                            }
                        }
                    }
                    content.linkSystem = generalSystemList
                    list.add(content)
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }
        }
        return list
    }

    /**
     * 查询 设备关联的资产 部件数量帮助接口
     */
    fun getEquipAssetComponentsToolsTwo(equipAssetComponentsList: List<EquipAssetComponentsReqponse>): ArrayList<EquipAssetComponentsReqponse> {
        /** 设备关联系统服务 */
        val viewEquipSystemservice = SBaseService(SMybatisDao(ViewEquipSystem::class.java))
        val generalSystemService = SBaseService(SMybatisDao(GeneralSystem::class.java))

        val list = ArrayList<EquipAssetComponentsReqponse>()
        if (equipAssetComponentsList.size!! > 0) {

            for (content in equipAssetComponentsList!!) {

                val exec = EquipmentService.select(SFilter.lte(SLength("classCode"), 6), SFilter.eq("parentId", content.id!!)).exec()

                content.count = exec.size

//                val exec1 = explainAllCategoriesService.select(SFilter.eq("parentId", content.category!!)).exec()
//                content.componentCategory = exec1

//                var equipAssetComponentsReqponse = EquipAssetComponentsReqponse()
//                equipAssetComponentsReqponse.id = content.id
//                equipAssetComponentsReqponse.linkId = content.linkId
//                equipAssetComponentsReqponse.linkEquipName = content.linkName
//                equipAssetComponentsReqponse.linkFamily = content.linkFamily
//                equipAssetComponentsReqponse.linkEquipLocalName = content.linkLocalName
//                equipAssetComponentsReqponse.count = exec.size
//                equipAssetComponentsReqponse.name = content.name
//                equipAssetComponentsReqponse.customParam = content.customParam
//                equipAssetComponentsReqponse.alram = content.alram
//                equipAssetComponentsReqponse.settingParam = content.settingParam
//                equipAssetComponentsReqponse.runParam = content.runParam
//                equipAssetComponentsReqponse.techParam = content.techParam
//                equipAssetComponentsReqponse.category = content.category
//                equipAssetComponentsReqponse.buildingId = content.buildingId
//                equipAssetComponentsReqponse.projectId = content.projectId
//                equipAssetComponentsReqponse.floorId = content.floorId
//                equipAssetComponentsReqponse.bimId = content.bimId
//                equipAssetComponentsReqponse.bimLocation = content.bimLocation
//                equipAssetComponentsReqponse.cadId = content.cadId
//                equipAssetComponentsReqponse.commParam = content.commParam
//                equipAssetComponentsReqponse.ledgerParam = content.ledgerParam
//                equipAssetComponentsReqponse.localId = content.localId
//                equipAssetComponentsReqponse.localName = content.localName
//                equipAssetComponentsReqponse.qrCode = content.qrCode
//                equipAssetComponentsReqponse.dpInsurerID = content.dpInsurerID
//                equipAssetComponentsReqponse.dpMaintainerID = content.dpMaintainerID
//                equipAssetComponentsReqponse.dpManufacturerID = content.dpManufacturerID
//                equipAssetComponentsReqponse.dpSupplierID = content.dpSupplierID
//                equipAssetComponentsReqponse.techParamGeneral = content.techParamGeneral
//                equipAssetComponentsReqponse.runParamGeneral = content.runParamGeneral

                val generalSystemList = ArrayList<GeneralSystem>()
                val systemList = viewEquipSystemservice.select(SFilter.eq("equipId", content.id!!)).exec()
                try {
                    if (!systemList.isEmpty()) {

                        for (system in systemList) {
                            if (!system.id.isNullOrEmpty()){
                                val systemEntity = generalSystemService.select(SFilter.eq("id", system.id!!)).entity()
                                if (systemEntity!=null){
                                    val generalSystem = GeneralSystem()
                                    generalSystem.id = system.id
                                    generalSystem.name = systemEntity.name
                                    generalSystem.localName = systemEntity.localName
                                    generalSystem.classCode = system.category
                                    generalSystemList.add(generalSystem)
                                }
                            }
                        }
                    }
                    content.linkSystem = generalSystemList
                    list.add(content)
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }
        }
        return list
    }

} // Object DataVerification