/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.messagecenter.models.entities


import com.persagy.server.datacenter.wanda.obj.Project
import com.persagy.server.messagecenter.models.entities.base.RBaseInfo
import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 消息中心
 *
 * @author  邓婷婷
 */
@Schema(description = "消息中心实体类")
@Table(name = "message.message")
open class Message: RBaseInfo(){

    /** ID */
    @Schema(description = "ID")
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 项目ID */
    @Schema(description = "项目ID")
    @Column(name = "project_id")
    var projectId: String? = null

    /** 标题 */
    @Schema(description = "标题")
    @Column(name = "title")
    var title: String? = null

    /** 发送消息的模块 */
    @Schema(description = "发送消息的模块")
    @Column(name = "module")
    var module: String? = null

    /** 枚举类型: Info, Warning, Error, Success */
    @Schema(description = "枚举类型: Info, Warning, Error, Success")
    @Column(name = "type")
    var type: String? = null

    /** 消息内容 */
    @Schema(description = "消息内容")
    @Column(name = "content")
    var content: MessageContent? = null

    /** 用户id */
    @Schema(description = "用户id")
    @Column(name = "user_id")
    var userId: String? = null

    /** 是否已读 */
    @Schema(description = "是否已读")
    @Column(name = "read")
    var read: Boolean? = null

    /** 级联-项目 */
    @Schema(description = "级联-项目")
    @SCascade(table="message.message", idColumn="id", childIdColumn="project_id")
    var project: ArrayList<Project>? = null

} // Class Message