/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.messagecenter.services

import com.persagy.server.messagecenter.models.entities.Message
import com.persagy.server.messagecenter.models.request.MessageRequest
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.messagecenter.services.base.RService
import com.persagy.service.SPageContext
import com.persagy.service.models.requests.SCreateRequest
import com.persagy.service.models.requests.SUpdateRequest
import com.persagy.service.models.responses.SBaseResponse
import org.slf4j.LoggerFactory
import org.springframework.web.bind.annotation.RequestBody
import java.util.*

/**
 * 消息表
 *
 * @author  邓婷婷
 */
object MessageService : RService<Message>(SMybatisDao(Message::class.java)){
    // 日志
    private val logger = LoggerFactory.getLogger(MessageService::class.java)

    fun createBefore(@RequestBody messageRequest: MessageRequest): SCreateRequest<Message> {
        val projectId = SPageContext.getHeader("projectId")
        val returnObj = SCreateRequest<Message>()
        var returnList = arrayListOf<Message>()

//        if(messageRequest.userList == null){//接收人列表为空时，表示所有用户都要接收到信息
//
//        }
        for(userId in messageRequest.userList!!){
            var message = Message()
            if(!projectId.isNullOrEmpty()){
                message.projectId = projectId
            }else{
                message.projectId = messageRequest.projectId
            }
            message.id = UUID.randomUUID().toString()
            message.title = messageRequest.title
            message.module = messageRequest.module
            message.type = messageRequest.type
            message.content = messageRequest.content
            message.read = false
            message.userId = userId
            (returnList as ArrayList<Message>).add(message)
        }
        returnObj.content = returnList
        return returnObj
    } // Fun createBefore

    /**
     * 更新状态为已读
     */
    fun updateMessageState(message : Message): SBaseResponse {
        val request = SUpdateRequest<Message>()

        val list = MessageService.select("userId" to message.userId!!,"read" to false).exec()
        for(m in list){
            m.read = true
        }
        request.content = list
        return MessageService.updateList(request)
    } // Fun updateMessageState

}