/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.controller

import com.persagy.server.util.QrCodeUntils
import io.swagger.v3.oas.annotations.Operation
import io.swagger.v3.oas.annotations.tags.Tag
import org.slf4j.LoggerFactory
import org.springframework.stereotype.Controller
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import java.io.IOException
import javax.imageio.ImageIO
import javax.servlet.ServletOutputStream
import javax.servlet.http.HttpServletResponse

/**
 * 二维码接口类
 *
 * @author  PLX
 */
@Tag(name = "010、二维码接口")
@Controller
@RequestMapping("/service/qrcode/")
open class QrCodeController {
    companion object {
        private val logger = LoggerFactory.getLogger(QrCodeController::class.java)
    } // companion object

//    /**
//     * 设备资产
//     */
//   @Operation(summary="设备资产", notes="")
//    @GetMapping("fm")
//    fun fm(projectId: String, fmId: String, response: HttpServletResponse) {
//        logger.debug("------------------------$projectId")
//        outQrCode("http://service.sagacloud.cn/qrcode/$fmId", response)
//        return
//    } // Function fm()

    /**
     * 二维码生成接口
     */
   @Operation(summary="二维码生成接口", description =  "")
    @GetMapping("zxing")
    fun point(Id: String, response: HttpServletResponse) {
        outQrCode("http://meos.sagacloud.cn/scan?key=$Id", response)
        return
    } // Function point()

    private fun outQrCode(contents: String, response: HttpServletResponse) {
        val buffImg = QrCodeUntils.createQrCode(contents, 400)

        // 禁止图像缓存
        response.setHeader("Pragma", "no-cache")
        response.setHeader("Cache-Control", "no-cache")
        response.setDateHeader("Expires", 0)
        response.contentType = "image/jpeg"

        // 将图像输出到Servlet输出流中
        val sos: ServletOutputStream
        try {
            sos = response.outputStream
            ImageIO.write(buffImg, "jpeg", sos)
            sos.close()
        } catch (e: IOException) {
            e.printStackTrace()
        }
        return
    } // Function outQrCode()

} // Class QrCodeController